<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/admin_top.php');
if (isset($_GET['delete']))
{
    $block = new UserBlock($_GET['delete']);
    $block->delete();
    header("Location: blocklist.php");
    exit;
}
if (isset($_GET['id']))
{
    $block = new UserBlock($_GET['id']);
    restore_form($block);
}
if (isset($_POST['submited']))
{
	$block = UserBlock::getUserBlock($_POST['UserBlockType'], $_POST['UserBlockPattern']);
	
	if (is_array($_POST['UserBlockResources']))
	{
		$resources = 0;
		foreach ($_POST['UserBlockResources'] as $resource)
		{
			$resources |= intval($resource);
		}

		$block->UserBlockResources = $resources;
	}

	if (empty($block->UserBlockPattern))
	{
        $template->touchBlock('UserBlockPattern_error');
		$error = true;
	}
    if ($block->UserBlockResources == 0)
    {
        $template->touchBlock('UserBlockResources_error');
        $error = true;
    }
    if (!$error)
    {
        $block->saveToDB();            
    }
    else
    {
        restore_form($block);
    }
}

$listing = new Listing();
$listing->onBeforeParseRow = parse_row;
$listing->parse($template, 'select * from userblock');

function restore_form($block)
{
    global $template;
    $template->setGlobalVariable('Pattern', $block->UserBlockPattern);
    $template->touchBlock('UserBlockType_' . $block->UserBlockType);
    foreach (array(USERBLOCK_RESOURCE_COMMUNITIES, USERBLOCK_RESOURCE_MARKETS, USERBLOCK_RESOURCE_MEDIA, 
        USERBLOCK_RESOURCE_MESSAGES, USERBLOCK_RESOURCE_INVITATIONS, USERBLOCK_RESOURCE_ALL) as $resource)
    {
        if ($block->checkResource($resource))
        {
            $template->touchBlock('UserBlockResources_' . $resource);
        }    
    }
}

function parse_row($tpl, $row)
{
	$block = new UserBlock();                 
	$block->populateFromArray($row);

	$tpl->setVariable('ResourceCommunities',	$block->checkResource(USERBLOCK_RESOURCE_COMMUNITIES));
	$tpl->setVariable('ResourceMarkets',		$block->checkResource(USERBLOCK_RESOURCE_MARKETS));
	$tpl->setVariable('ResourceMedia',			$block->checkResource(USERBLOCK_RESOURCE_MEDIA));
	$tpl->setVariable('ResourceMessages',		$block->checkResource(USERBLOCK_RESOURCE_MESSAGES));
	$tpl->setVariable('ResourceInvitations',	$block->checkResource(USERBLOCK_RESOURCE_INVITATIONS));
	$tpl->setVariable('ResourceAll',			$block->checkResource(USERBLOCK_RESOURCE_ALL));
    
    if ($block->UserBlockID == intval(@$_GET['id']))
    {
        $tpl->parse('pattern');
    }
    else
    {
        $tpl->parse('link');
        $tpl->setVariable('UserBlockID', $block->UserBlockID);
    }
}

require_once('includes/admin_bottom.php');
?>