<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'albums';
require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_MEDIA))
{
    cmn_unauthorized_action();
}

$album = new Album($_GET['album_id']);

if ($album->AlbumID != -1)
{
    $owner = $album->getOwner();
    $type = strtolower(get_class($owner));
    $owner_id   = $owner->{ucfirst(get_class($owner)) . 'ID'};

    if ($type != 'user')
    {
        if (!$owner->userIsAdmin($user->UserID) && $owner->{ucfirst($type) . 'Status'} != GROUP_STATUS_PUBLIC)
        {
            cmn_unauthorized_action();
        }
        $template->setVariable('Entity', $type);
        $template->setVariable('EntityID',   $owner_id);
        $template->parse('back_link');
    }

	if ($album->checkPermission('edit'))
	{
	    if ($_POST['action'] == 'upload')
	    {
	    	//print_r($_FILES); die();
	    	if ($_FILES['photofile']['tmp_name']['size'] > 3145728)
	    	{
	    		$template->touchBlock('size_error');
	    	}
	    	else
	    	{
		        $path = './tmp/album/' . $_GET['album_id'] . '/';
		        cmn_create_path($path, false);
		        $d = dir($path);
		        $photos = array();
		        while (false !== ($file = $d->read()))
		        {
		            if ($file != '.' && $file != '..')
		            {
		            	if (filesize($path.$file) <= MAX_UPLOAD_FILE_SIZE)
		            	{
			                $pathinfo = pathinfo($file);

			                $photo = new Photo();
			                $photo->AlbumID = $album->AlbumID;
			                $photo->PhotoPath = time() . $pathinfo['basename'];
			                $photo->PhotoName = $pathinfo['basename'];
			                $photo->saveToDB();

			                cmn_create_path(PATH_ALBUM_PICS . $album->AlbumID, false);
			                cmn_create_path(PATH_ALBUM_PICS . $album->AlbumID . "/original" , false);
			                rename($path . $file, PATH_ALBUM_PICS . $album->AlbumID . "/original/" . $pathinfo['basename']);
			                $uploaded_file = PATH_ALBUM_PICS . $album->AlbumID . "/original/" . $pathinfo['basename'];

			                $photopath = PATH_ALBUM_PICS . $album->AlbumID;
			                $previewpath = PATH_ALBUM_PICS . '/' . $album->AlbumID . '/previews';
			                $photoname = $photo->PhotoID;
			                $photos[] = $photo;
			                cmn_create_path($previewpath, false);

			                $thumb = new Thumbnail($uploaded_file);
			                $thumb->setNewFilename($photo->PhotoPath);

			                $thumb->setSavePath($photopath);
			                $thumb->setDimension(ALBUM_PHOTO_WIDTH, ALBUM_PHOTO_HEIGHT);
			                $thumb->resize();

			                $thumb1 = new Thumbnail($uploaded_file);
			                $thumb1->setNewFilename($photo->PhotoPath);
			                $thumb1->setSavePath($previewpath);
			                $thumb1->setDimension(ALBUM_PHOTOPREVIEW_WIDTH, ALBUM_PHOTOPREVIEW_HEIGHT);
			                $thumb1->resize();
			                unlink($uploaded_file);
			                //move_uploaded_file($_FILES['photofile']['tmp_name'], PATH_ALBUM_PICS . $album->AlbumID . "/" . $photo->PhotoID);
		            	}
		            }
		        }
		        cmn_remove_directory($path);
		        foreach ($photos as $photo)
		        {
		             $template->setVariable('PhotoID',        $photo->PhotoID);
		             $template->setVariable('PhotoName',      $photo->PhotoName);
		             $template->setVariable('PhotoThumbnail', $photo->getPhotoURL(true));
		             $template->parse('photo_line');
		        }
		        $template->touchBlock('photos_form');
		        $template->hideBlock('upload_form');
		        $template->touchBlock('buttons');
	    	}
	    }
	    else if ($_POST['action'] == 'save')
	    {
	    	if (is_array($_POST['PhotoName']))
	        foreach ($_POST['PhotoName'] as $id => $name)
	        {
	            $photo = new Photo($id);
	            if (isset($_POST['delphoto'][$id]))
	            {
	                $photo->delete();
	                continue;
	            }

	            if (isset($_POST['AlbumCoverID']) && $_POST['AlbumCoverID'] == $id)
	            {
	                $album->clearCover();
	                $photo->PhotoIsCover = 1;
	            }
	            $photo->PhotoName = $name;
	            $photo->saveToDB();
	        }
	        cmn_redirect('albums.php?type=' . $type . '&id=' . $owner_id);
	    }
	    else
	    {
	        $template->touchBlock('upload_form');
	        $template->touchBlock('upload_object');
	        $template->touchBlock('steps');
	        $template->hideBlock('buttons');
	        $template->setGlobalVariable('album_id', $album->AlbumID);
	        $template->setGlobalVariable('AlbumID', $album->AlbumID);
	        $template->setVariable('session_id', session_id());
	    }
	}
	else
	{
	    cmn_unathorized_action();
	}
}
else
{
	cmn_unauthorized_action();
}
$template->setVariable('UPLOAD_SCRIPT_PATH', BASE_DIR);
require_once('includes/application_bottom.php');
