<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'blog';
include('includes/application_top.php');
$template->setGlobalVariable('SectionHeader', 'My Blog');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$tab = $_GET['tab'] ? $_GET['tab'] : 0;

$members = $user->getBuddies();

for ($i = 0; $i < count($members); $i++)
{
	if (($count = $members[$i]->getBlogEntryCount()) > 0)
	{
		$template->setVariable('UserID',	$members[$i]->UserID);
		$template->setVariable('UserFirstname', $members[$i]->UserFirstname);
		$template->setVariable('UserLastname', $members[$i]->UserLastname);
		$template->setVariable('BlogEntryCount', $count);
		$template->parse('member');
	}
}

$member = new User(@$_GET['id']);
if ($member->UserID == -1)
{
	$member = $user;
	$template->touchBlock('my');
}
else
{
	$template->setVariable('Username', db_get_entity_display_name($member));
	$template->parse('other');
}

if (isset($_GET['delete']))
{
    $blogentry = new BlogEntry($_GET['delete']);
    if ($blogentry->UserID == $user->UserID)
    {
        $blogentry->delete();
    }
}

$blogEntries = $member->getBlogEntries();
foreach ($blogEntries as $blogEntry)
{
	if ($blogEntry->userIsAllowedToReadEntry($user->UserID))
	{
		$template->setVariable('BlogEntryID', $blogEntry->BlogEntryID);
		$template->setVariable('BlogEntrySubject', $blogEntry->BlogEntrySubject);
		$template->setVariable('BlogEntryDate', $blogEntry->BlogEntryDate);
		$template->setVariable('BlogEntryCropMessage', substr($blogEntry->BlogEntryMessage, 0, BLOG_ENTRY_PREVIEW_SIZE) . '...');
		$template->setVariable('BlogEntryMessage', $blogEntry->BlogEntryMessage);
		$template->setVariable('TAG_TYPE_BLOG_ENTRY', TAG_TYPE_BLOG_ENTRY);

		$checked = $blogEntry->OnlyMyFlag == 1 ? 'checked' : '';
		$template->setVariable('checked', $checked);

		$template->parse('blogentry');
	}
}

$template->setVariable('tab', $tab);

include('includes/application_bottom.php');