<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

if (!isset($_GET['limit']))
{
    $_GET['limit'] = 10;
}

$arrGetAttrs = array('unblock', 'request', 'remove', 'buddy'); // for self linking

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$display = 'user';
if (isset($_GET['display']))
{
	$display = $_GET['display'];
}

switch($display)
{
    case 'group':
    	$template->setVariable('tab', 1);
    break;
    
    case 'user':
    default:
    	$template->setVariable('tab', 0);
}

$template->setVariable('SectionHeader',	'Search Directory');
$template->setVariable('ChangeTabLink',	cmn_self_link('display', '', array_merge($arrGetAttrs, array('page', 'sort'))));
$template->setVariable('Display',		$display);

if (@$_GET['search_expanded'] != 'true')
{
    $template->setVariable('SearchExpanded', 'false');
    $template->touchBlock('directory_search_content_hide');
}
else
{
    $template->setVariable('SearchExpanded', 'true');
}

if (@$_GET['mapping_expanded'] != 'true')
{
    $template->touchBlock('directory_mapping_content_hide');
    $template->setVariable('MappingExpanded', 'false');  
}
else
{
    $template->setVariable('MappingExpanded', 'true');
}

if (@$_GET['more'] == 'true')
{
    $template->touchBlock('more_options');
}


$template->touchBlock($display . '_selected');

switch ($display)
{
	case 'group':
    
		if (isset($_GET['request']))
		{
			$obj = Entity::getObject($display, $_GET['request']);
			if ($obj->{db_get_entity_key($obj)} != -1)
			{
				if (!$obj->isPublic())
				{
					if ($obj->isJoinRequested($user->UserID))
					{
						$template->setVariable('RequestName', $obj->{db_get_entity_name($obj)});
						$template->parse('error_already_requested');
					}
					else
					{
						cmn_redirect(
							'group_request.php?request_id=' . $obj->{db_get_entity_key($obj)} .
							'&return=' . urlencode(cmn_self_link('', '', array('request'))));
					}
				}
				else
				{
					$obj->addMember($user->UserID);
				}
			}
		}
		else if (isset($_GET['remove']))
		{
			$obj = Entity::getObject($display, $_GET['remove']);
			if ($obj->{db_get_entity_key($obj)} != -1)
			{
				$obj->removeMember($user->UserID);
			}
		}

	case 'user':

		if (isset($_GET['buddy']))
		{
			$member = new User($_GET['buddy']);
			if ($member->UserID != -1)
			{
				if ($member->isBuddy($user->UserID))
				{
					$member->removeBuddy($user->UserID);
				}
				else
				{
					if ($member->isBuddyRequested($user->UserID))
					{
						$template->setVariable('BuddyName', $member->UserFirstname . ' ' . $member->UserLastname);
						$template->parse('error_already_buddy_requested');
					}
					else
					{
						cmn_redirect('buddy_request.php?id=' . $member->UserID .
							'&return=' . urlencode(cmn_self_link('', '', array('buddy'))));
					}
				}
			}
		}

		if (isset($_GET['unblock']))
		{
			$obj = Entity::getObject($display, $_GET['unblock']);
			$user->unblock($obj);
		}

		// adding to block list?
        if (isset($_POST['connections']))
		{
			foreach (array('User', 'Group') as $entity)
			{
				if (is_array(@$_POST[$entity . 'ID']))
				{
					foreach ($_POST[$entity . 'ID'] as $id)
					{
						$obj = Entity::getObject($entity, $id);
						$user->block($obj);
					}
				}
			}
		}

		$template->touchBlock('connections_sort');

		$template->setVariable('ChangeSortLink', cmn_self_link('sort', '', $arrGetAttrs));

		$sort = '';

		switch ($_GET['sort'])
		{
			case 'title':
			case 'created':
			case 'updated':
			case 'rating':
			case 'connections':

				$sort = ' ORDER BY ' . ucfirst($_GET['sort']);
				$template->touchBlock($_GET['sort'] . '_sort_selected');
		}

		$entities 					= array();
		$entities['User']			= array();
		$entities['Group']			= array();
		
		foreach ($_GET as $field => $value)
		{
			if ($value != '')
			{
				$value = ud_sanitize($value);

				switch ($field)
				{
					case 'Name':
						$entities['User'][] = '(UPPER(UserFirstname) LIKE \'%%' . strtoupper($value) . '%%\' OR UPPER(UserLastname) LIKE \'%%' . strtoupper($value) . '%%\')';
						$entities['Group'][] = 'UPPER(GroupName) like \'%%' . $value . '%%\'';
						
						$template->setVariable($field, $value);
						break;

					case 'Keywords':
						$entities['Group'][] = 'UPPER(GroupKeywords) like \'%%' . strtoupper($value) . '%%\'';
						$entities['User'][] = '(UPPER(UserEmail) \'%%' . strtoupper($value) . '%%\' OR UPPER(UserFirstname) LIKE \'%%' . strtoupper($value) . '%%\' OR UPPER(UserLastname) LIKE \'%%' . strtoupper($value) . '%%\')';
						$template->setVariable($field, $value);
						break;

                    case 'State':
                    case 'Country':
                    case 'Zip':
                    case 'City':

                    	$entities['User'][] = 'UPPER(User' . $field . ') like \'%%' . strtoupper($value) . '%%\'';

                    	$template->setVariable($field, $value);
                    	break;

                    /*
                    case 'Location':
                    	if (!isset($entities['User']['School']))
                    	{
                    		$entities['User']['School'] = array();
                    	}
                    	$entities['User']['School'][]  = 's.`' . $field . '` like \'%%' . $value . '%%\'';

                    	$template->setVariable($field, $value);
                    	break;*/

                    case 'CompanyName':
                    case 'CompanyUserTitle':
                    case 'CompanyStartDate':
                    case 'CompanyEndDate':


                        if (!isset($entities['User']['Company']))
                        {
                            $entities['User']['Company'] = array();
                        }
                        $entities['User']['Company'][]  = 'UPPER(c.`' . $field . '`) like \'%%' . strtoupper($value) . '%%\'';

                        $template->setVariable($field, $value);

                        break;

                    case 'SchoolName':
                    case 'SchoolStartDate':
                    case 'SchoolEndDate':
                        if (!isset($entities['User']['School']))
                        {
                            $entities['User']['School'] = array();
                        }
                        $entities['User']['School'][]  = 'UPPER(s.`' . $field . '`) like \'%%' . strtoupper($value) . '%%\'';

                        $template->setVariable($field, $value);
                        break;

                    case 'Interests':
						$entities['User'][] = '(UPPER(UserInterests) like \'%%' . strtoupper($value) .
							'%%\' or UPPER(UserFavouriteInterests) like \'%%' . strtoupper($value) .
							'%%\' or UPPER(UserInterestsOther) like \'%%' . strtoupper($value) . '%%\')';
                    	$template->setVariable($field, $value);
                    	break;

                    case 'Activities':
						$entities['User'][] = 'UPPER(UserFavouriteActivities) like \'%%' . strtoupper($value) . '%%\'';
						$template->setVariable($field, $value);
                    	break;

                    case 'Skills':
                        if (!isset($entities['User']['Skill']))
                        {
                            $entities['User']['Skill'] = array();
                        }
                        $entities['User']['Skill'][]  = 'UPPER(sk.`' . $field . '`) like \'%%' . strtoupper($value) . '%%\'';
                        $template->setVariable($field, $value);
                    	break;

                     case 'Services':
                     	foreach ($entities as $entity => $tmp)
                     	{
                            if (!isset($entities[$entity]['Product']))
                            {
                                $entities[$entity]['Product'] = array();
                            }
                            $entities['User']['Product'][]  = 'UPPER(p.`ProductName`) like \'%%' . strtoupper($value) . '%%\' and p.ProductCategory = ' . PRODUCT_CATEGORY_SERVICE;
						}

                        $template->setVariable($field, $value);
                     	break;

                     case 'Availability':
                     	foreach (array('User', 'Group', 'Organization', 'Community') as $entity)
                     	{
                            if (!isset($entities[$entity]['Event']))
                            {
                                $entities[$entity]['Event'] = array();
                            }

                     		if (!empty($value['Day']))
                     		{
                     			$entities[$entity]['Event'][] = 'dayofweek(e.EventStartDate) != ' . intval($value['Day']);
                     			$template->touchBlock('AvailabilityDay_' . $value['Day']);
							}

							if (preg_match('/^(\d+)\:(\d+)(?:\:(\d+))?$/', $value['From'], $matches))
							{
								$time = '\'' . $matches[1] . ':' . $matches[2] . (isset($matches[3]) ? $matches[3] : ':00') . '\'';
								$entities[$entity]['Event'][] = 'e.EventStartDate < ' . $time . ' and e.EventEndDate < ' . $time;
								$template->setVariable('AvailabilityFrom', $value['From']);
							}
							if (preg_match('/^(\d+)\:(\d+)(?:\:(\d+))?$/', $value['To'], $matches))
							{
								$time = '\'' . $matches[1] . ':' . $matches[2] . (isset($matches[3]) ? $matches[3] : ':00') . '\'';
								$entities[$entity]['Event'][] = 'e.EventStartDate > ' . $time . ' and e.EventEndDate > ' . $time;
								$template->setVariable('AvailabilityTo', $value['To']);
							}
						}
						break;

                     case 'Products':
                        $entities['User']['Product'][]  = '(UPPER(p.`ProductName`) like \'%%' . strtoupper($value) . '%%\' and (p.ProductCategory = ' .
                            PRODUCT_CATEGORY_MERCHANDISE . ' or p.ProductCategory = ' . PRODUCT_CATEGORY_DIGITAL . '))';

                        $template->setVariable($field, $value);
                     	break;

				}
			}
		}

        // search based on my information
        if (isset($_GET['my_info']))
        {
            $companies = $user->getCompanies();

            if (count($companies))
            {
                $entities['User']['Company'] = array();

                foreach (array('CompanyName', 'CompanyUserTitle', 'CompanyStartDate', 'CompanyEndDate') as $field)
                {
                    $query = array();
                    foreach ($companies as $company)
                    {
                        $query[] =  'UPPER(c.' . $field . ') like \'%%' . strtoupper($company->{$field}) . '%%\'';
                    }
                    if (count($query))
                    {
                        $entities['User']['Company'][] = '(' . join(' or ', $query) . ')';
                    }
                }
            }

            $schools = $user->getSchools();

            if (count($schools))
            {
                $entities['User']['School']  = array();

                foreach (array('SchoolName', 'SchoolStartDate', 'SchoolEndDate') as $field)
                {
                    $query = array();
                    foreach ($schools as $school)
                    {
                        $query[] =  'UPPER(c.' . $field . ') like \'%%' . strtoupper($school->{$field}) . '%%\'';
                    }
                    if (count($query))
                    {
                        $entities['User']['School'][] = '(' . join(' or ', $query) . ')';
                    }
                }
            }
            $template->touchBlock('my_info');
        }

		$db = DBConnect::getInstance();

        /**/
         //print_r($entities);
        /**/

        foreach ($entities as $entity => $where)
		{
			$table = strtolower($entity);
            $query = '';

			switch ($entity)
			{
				case 'User':

					$joins = '';

                    if (isset($where['Company']))
                    {
                        $joins .= ' inner join company c on c.UserID = u.UserID and ' . join(' and ', $where['Company']);
                        unset($where['Company']);
                    }

                    if (isset($where['School']))
                    {
                        $joins .= ' inner join school s on s.UserID = u.UserID and ' . join(' and ', $where['School']);
                        unset($where['School']);
                    }

                    if (isset($where['Skill']))
                    {
                        $joins .= ' inner join skill sk on sk.UserID = u.UserID and ' . join(' and ', $where['Skill']);
                        unset($where['Skill']);
                    }

					$where[] = 'UserType = ' . USER_TYPE_MEMBER;
					$where[] = 'u.UserStatus = ' . USER_STATUS_ACTIVE;

					if (isset($where['Event']))
                    {
                    	$joins .= ' LEFT JOIN `connection` AS cg ON cg.GroupID <> -1 AND cg.UserID = u.UserID LEFT JOIN `connection` AS co ON co.OrganizationID <> -1 AND cg.UserID = u.UserID LEFT JOIN `eventtoparticipant` AS ep ON ep.UserID = u.UserID left join event e on e.UserID = u.UserID OR ep.EventID = e.EventID OR co.OrganizationID = e.OrganizationID OR cg.GroupID = e.GroupID';
                    	foreach ($where['Event'] as $expr)
                    	{
                    	    $where[] = $expr;
						}
						unset($where['Event']);
					}

					$joins .= ' LEFT JOIN `connection` AS con ON con.UserID = u.UserID AND (con.ConnectionType = ' . CONNECTIONTYPE_MEMBER . ' OR con.ConnectionType = ' . CONNECTIONTYPE_ADMIN . ' OR con.ConnectionType = ' . CONNECTIONTYPE_OWNER . ') OR con.ConnectionType = ' . CONNECTIONTYPE_BUDDY . ' AND (con.ToUserID = u.UserID OR con.UserID = u.UserID)';
					$joins .= ' WHERE ' . join(' AND ', $where);

					if ($table == $display)
					{
						$listing = new Listing('listing.connections.html', 'listing');
						$listing->onBeforeParseRow = parseConnection;

						$listing->parse($template, 'SELECT count(con.ConnectionID) AS Connections, UserRegistrationDate AS Created, ' .
							'UserUpdated AS Updated, u.UserPicture AS Picture, \'User\' AS Entity,
							CONCAT_WS(\' \', u.UserFirstname, \' \', u.UserLastname) AS Title, u.UserID AS ID FROM `user` AS u ' .
							$joins . ' GROUP BY u.UserID ' . $sort);

						$entities[$entity] = $listing->DataSource->Size;
					}
					else
					{

                        $result = $db->query('SELECT COUNT(*) AS cnt FROM `user` WHERE UserType = ' . USER_TYPE_MEMBER);
						$entities[$entity] = $result->Data[0]['cnt'];
					}

					break;

				case 'Group':

					if (isset($where['Event']))
                    {
                    	$query .= ' left join event e on e.' . $entity . 'ID = co.' . $entity . 'ID';
                    	foreach ($where['Event'] as $expr)
                    	{
                    	    $where[] = $expr;
						}
						unset($where['Event']);
					}

                    $where[] = 'GroupStatus != ' . GROUP_STATUS_PRIVATE;
					$query .= ' WHERE ' . join(' AND ', $where);

					if ($table == $display)
					{
						$listing = new Listing('listing.connections.html', 'listing');
						$listing->onBeforeParseRow = parseConnection;
						$listing->parse($template, 'SELECT COUNT(con.ConnectionID) AS Connections, ' . $entity . 'Created AS Created, ' .
							$entity . 'Updated AS Updated, ' . $entity . 'Picture AS Picture, \'' . $entity . '\' AS Entity, co.' . $entity .
							'Name' . ' AS Title, co.' . $entity . 'ID AS ID FROM `' . $table . '` co LEFT JOIN `connection` AS con ON ConnectionType = ' .
							CONNECTIONTYPE_MEMBER . ' AND con.' . $entity . 'ID' . ' = co.' . $entity . 'ID AND con.UserID = -1 ' . $query . ' GROUP BY co.' . $entity . 'ID ' . $sort);

						$entities[$entity] = $listing->DataSource->Size;
					}
					else
					{
						$result = $db->query('SELECT COUNT(*) AS cnt FROM `' . $table . '` AS co ' . $query);
						$entities[$entity] = $result->Data[0]['cnt'];
					}

					break;
			}
		}

        switch ($display)
		{
			case 'user':

                if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
                {
				    $unions = $user->getGroups(true); // can be getUnions

				    foreach ($unions as $union)
				    {
					    $template->setVariable('UnionEntity', strtolower(get_class($union)));
					    $template->setVariable('UnionID', $union->{db_get_entity_key($union)});
					    $template->setVariable('UnionName', $union->{db_get_entity_name($union)});
					    $template->parse('union');
				    }
                    $template->parse('add_to_group');
                }

			case 'group':

				$template->touchBlock('buttons_' . $display);
				$template->parse('buttons_' . $display);
				break;

			default:
				$template->touchBlock('buttons_other');
				$template->parse('buttons_other');
		}

		$template->touchBlock($display . '_selected');

		foreach ($entities as $entity => $count)
		{
			$template->setVariable($entity . 'Count', intval($count));
		}
		break;

		default:
			cmn_unauthorized_action();
}

function parseConnection($tpl, $row)
{
	global $user, $arrGetAttrs;

	$obj = Entity::getObject($row['Entity'], $row['ID']);

	switch ($row['Entity'])
	{
		case 'User':

			if ($row['ID'] != $user->UserID)
			{
				$tpl->setVariable('BuddyLink', cmn_self_link('buddy', $row['ID'], $arrGetAttrs));

				if ($user->isBuddy($row['ID']))
				{
					$tpl->parse('remove_buddy');
				}
				elseif ($user->isBuddyRequested($row['ID']))
				{
					$tpl->hideBlock('remove_buddy');
					$tpl->touchBlock('connection_pending');
				}
				else
				{
					$tpl->parse('add_to_buddy');
				}
				$tpl->touchBlock('send_message');
			}
			break;

		case 'Group':

			$tpl->setVariable('MembersLink', cmn_get_profile_link('Group', $row['ID']));
			$tpl->setVariable('MembersCount',
				count
				(
					Connection::getConnections
					(
						array
						(
							'ConnectionType'	=> array(CONNECTIONTYPE_OWNER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER),
							'UserID'			=> '<> -1',
							'GroupID'			=> $row['ID']
						)
					)
				)
			);

			$tpl->parse('size');
            $tpl->setVariable('Description', $obj->GroupDescription);
            $tpl->parse('description');
            $tpl->setVariable('Keywords', $obj->GroupKeywords);
            $tpl->parse('keywords');
            $group = new Group($row['ID']);

            if ($obj->isJoinRequested($user->UserID))
            {        
                $tpl->touchBlock('connection_pending');
            }
            else
            {
                if (!$group->isOwner($user->UserID))
                {
                    if ($group->hasMember($user->UserID))
                    {
                        $tpl->setVariable('BuddyLink', cmn_self_link('remove', $row['ID'], $arrGetAttrs));
                        $tpl->parse('remove_buddy');
                    }
                    else
                    {
                        $tpl->setVariable('BuddyLink', cmn_self_link('request', $row['ID'], $arrGetAttrs));
                        $tpl->parse('add_to_buddy');
                    }                
                }
                if ($group->userIsAdmin($user->UserID))
                {
                    $tpl->setVariable('EditLink', 'group_profile.php?group_id=' . $group->GroupID);
                    $tpl->parse('edit');
                }
            }
        
	}

	$tpl->setVariable('EntityLink', cmn_get_profile_link($row['Entity'], $row['ID']));

	$db = DBConnect::getInstance();
	if ($row['Entity'] == 'User')
	{
		$result = $db->query('select * from `connection` AS c ' .
			'INNER JOIN `user` AS u ON u.UserID = c.ToUserID ' .
			'where (c.ConnectionType = %d or c.ConnectionType = %d or c.ConnectionType = %d or c.ConnectionType = %d) and c.UserID = %d ' .
			'AND u.UserStatus <> %d ' .
			 'limit 5',
			CONNECTIONTYPE_BUDDY, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID'], USER_STATUS_DEACTIVATED);
	}
	else
	{
		$result = $db->query('select * from `connection` where (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) ' .
			'and (' . $row['Entity'] . 'ID' . ' = %d or To' . $row['Entity'] . 'ID' . ' = %d) and UserID = -1 limit 5',
			CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID'], $row['ID']);
	}

	foreach ($result->Data as $data)
	{
		$connection = new Connection();
		$connection->populateFromArray($data);

		$target = $connection->getTarget($obj);

		$tpl->setVariable('ConnectionLink', cmn_get_profile_link(get_class($target), $target->{db_get_entity_key($target)}));
		$tpl->setVariable('ConnectionTitle', db_get_entity_display_name($target));
		$tpl->parse('connection');
	}

	if (!count($result->Data))
	{
		$tpl->touchBlock('connections_none');
	}
	//////

	if (empty($row['Picture']))
	{
		$tpl->touchBlock('no_picture');
		$tpl->hideBlock('picture');
	}
	else
	{
		$tpl->setVariable('Entity', $row['Entity']);
		//$tpl->setVariable('EntityID', $row['ID']);
		//$tpl->parse('picture');
	}

	if ($user->isBlocked($obj))
	{
		$tpl->setVariable('UnblockLink', cmn_self_link('unblock', $row['ID'], $arrGetAttrs));
		$tpl->setVariable('UnblockEntity', $row['Entity']);
		$tpl->parse('unblock');
	}
}
include('includes/application_bottom.php');
?>