<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

$section = 'calendar';
require_once('includes/application_top.php');


if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$event = new Event(@$_GET['id']);
if ($event->EventID != -1)
{
	$owner = $event->getOwner();
	if ($owner->checkCalendarPrivacy($user->UserID))
	{
		if (isset($_GET['unsubscribe']))
		{
			$event->unsubscribe($user->UserID);
		}
		else if (isset($_GET['subscribe']))
		{
			if ($event->EventType != EVENT_TYPE_FREE && $event->EventAvailability == EVENT_AVAILABILITY_PRIVATE && !$event->isSubscribed($user->UserID))
			{
				if ($event->isSubscriptionRequested($user->UserID))
				{
					$template->touchBlock('already_requested');
				}
				else
				{
					cmn_redirect('event_request.php?id=' . $event->EventID);
				}
			}
			else
			{
				$event->addParticipant($user->UserID);
			}
		}

		$template->setVariable(get_object_vars($owner));
		$vars = get_object_vars($event);

        if ($vars['EventType'] != EVENT_TYPE_GROUP)
        {
            unset($vars['EventCost']);
        }
        
        if (!empty($vars['EventLocationCountry']))
        {
            $country = new Country($vars['EventLocationCountry']);
            $vars['EventLocationCountry'] = $country->CountryName;
        }

        if (!empty($vars['EventLocationState']))
        {
            //$state = new State($vars['EventLocationState']);
            //$vars['EventLocationState'] = $state->StateName;
        }

		for ($i = 1; $i <= 4; $i++)
		{
			if (!file_exists(PATH_EVENT_PICS . $event->EventID . '/' . $vars['EventPicture' . $i]))
			{
				unset($vars['EventPicture' . $i]);
			}
		}

        foreach ($vars as $var => $value)
        {
            if ($value !== '')
            {
                $template->setVariable($var, $value);
            }

        }


		$template->setGlobalVariable('_EventID', $event->EventID);


        $subscribed = $event->isSubscribed($user->UserID);
        if ($event->EventAvailability == EVENT_AVAILABILITY_PUBLIC || $subscribed)
        {
            if (!$event->isOwner($user->UserID) && $subscribed)
            {
                $template->touchBlock('unsubscribe');
            }

            if ($event->isAdmin($user->UserID))
            {
                if (!UserBlock::checkUserBlockResources(USER_BLOCKED_RESOURCES, USERBLOCK_RESOURCE_INVITATIONS))
                {
                    $template->touchBlock('event_invite');
                }

                $template->touchBlock('guest_list');
            }


            if (!$subscribed)
            {
                $template->touchBlock('subscribe');
            }
        }
        else
        {
            if ($event->EventType != EVENT_TYPE_FREE)
            {
                $template->touchBlock('subscribe_request');
            }

        }
	}
	else
	{
		cmn_unauthorized_action();
	}
}

require_once('includes/application_bottom.php');