<?
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$form_id = isset($_GET['form_id']) ? $_GET['form_id'] : ( isset($_POST['FormID']) ? $_POST['FormID'] : -1 );
$form = new Form($form_id);

$object = $form->getOwner();
$entity = ucfirst(get_class($object));
$id = $object->{db_get_entity_key($object)};
$submission_id = $_GET['submission_id'];

//if ( ($id == -1) || (!$object->hasMember($user->UserID)) )
if ($id < 1)
{
	cmn_unauthorized_action();
}

if ($_POST['submitted'])
{
	// deleting pending user form submission record to add active submissions
	$pending_submission = new FormSubmission($submission_id);
	$pending_submission->delete();

    foreach ($_POST['FormFieldValue'] as $field_id => $field_value)
    {
	    $form_submission = new FormSubmission();
	    $form_submission->UserID = $user->UserID;
	    $form_submission->FormID = $form_id;
	    $form_submission->FormSubmissionStatus = FORM_SUBMISSION_STATUS_SUBMITTED;
    	$form_submission->FormFieldID = $field_id;

    	$form_submission->FormFieldValue = $field_value;
    	$form_submission->saveToDB();
	}

    foreach ($_POST['FormFieldOption'] as $field_id => $option_id)
    {
	    $form_submission = new FormSubmission();
	    $form_submission->UserID = $user->UserID;
	    $form_submission->FormID = $form_id;
	    $form_submission->FormSubmissionStatus = FORM_SUBMISSION_STATUS_SUBMITTED;
        $form_submission->FormFieldID = $field_id;

    	$form_submission->FormFieldOptionID = $option_id;
    	$form_submission->saveToDB();
	}

	print '<script type="text/javascript">self.close();</script>'; exit(0);
}

$form_fields = $form->getFormFields();
foreach ($form_fields as $field)
{
	if ($field->FormFieldType != FORM_FIELD_TYPE_MULTIPLE)
	{
        $template->setVariable('FormFieldID', $field->FormFieldID);
        $template->parse('form_field_text');
	}
	else
	{
        $form_field_options = $field->getFormFieldOptions();
        foreach ($form_field_options as $option)
        {
            $template->setVariable('FormFieldOptionID', $option->FormFieldOptionID);
            $template->setVariable('FormFieldOptionValue', $option->FormFieldOptionValue);
        	$template->parse('options');
		}
        $template->setVariable('FormFieldID', $field->FormFieldID);
        $template->parse('form_field_option');
	}

	$template->setVariable('FormFieldName', $field->FormFieldName);
	$template->parse('form_field');
}

require_once('includes/application_bottom.php');