<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

$tab = isset($_GET['tab']) ? $_GET['tab'] : 0;
$template->setGlobalVariable('tab', $tab);

// Manage Members
function manage_members()
{
	global $user, $template, $EXCEL_MEMBER_SHEET_COLUMN_NAMES;

	if (!Session::isCurrentSessionLoggedIn())
	{
		cmn_unauthorized_action();
	}

	$group_id = isset($_GET['group_id']) ? $_GET['group_id'] : ( isset($_POST['group_id']) ? $_POST['group_id'] : -1 );
	$group = new Group($group_id);

	$data = $group->getDataArray();

	if (!$group->userIsAdmin($user->UserID) || $group->GroupID == -1)
	{
		cmn_unauthorized_action();
	}

	if ($_POST['submitted'] == 'true')
	{
		if (is_array($_POST['MemberID']) && is_array($_POST['TeamMemberID']))
		{
			$members = array_merge(
			array_keys($_POST['MemberID']),
			array_keys($_POST['TeamMemberID']));
		}
		elseif (!is_array($_POST['MemberID']) && is_array($_POST['TeamMemberID']))
		{
			$members = array_keys($_POST['TeamMemberID']);
		}
		elseif (is_array($_POST['MemberID']) && !is_array($_POST['TeamMemberID']))
		{
			$members = array_keys($_POST['MemberID']);
		}
		else
		{
			$error = true;
		}


		if ($_POST['action'] == 'change_status' && !empty($_POST['member_id']))
		{
			$member_id = $_POST['member_id'];
			$member_status = $_POST['UserStatus'][$member_id];

			$group->changeUserStatusInGroup($member_id, $member_status);
		}
		elseif ($_POST['action'] == 'send_admin_invitations' && !empty($members))
		{
			foreach ($members as $key => $value)
			{
				$invitation = new Invitation();
				$invitation->GroupID = $group->GroupID;
				$invitation->OrganizationID = '';
				$invitation->FromUserID = $user->UserID;
				$invitation->ToUserID = $value;
				$invitation->InvitationPermissions = CONNECTIONTYPE_ADMIN;
				$invitation->saveToDB();
				
				$messageText = 'Join my group as administrator';
				Message::sendGroupAdminInvite($user->UserID, $value, $group->GroupID, $messageText);
				$template->touchBlock('invitations_is_sent');
			}
		}
		elseif ($_POST['action'] == 'send_message' && !empty($members))
		{
			$message = new Message();

			$message_text = $_POST['Message'];
			$message_subject = 'Message';
			$use_user_id = $user->UserID;

			foreach ($members as $key => $member_id)
			{
				$message->sendUserMessage($use_user_id, $member_id, $message_subject, $message_text);
			}

			$template->touchBlock('msg_is_sent');
		}
		elseif ($_POST['action'] == 'send_email_message' && !empty($members))
		{
			$message_text = $_POST['Message'];

			foreach ($members as $key => $member_id)
			{
				$user_email = User::getUserEmailById($member_id);
				Message::sendEmail($user_email, 'Email message', $message_text);
			}

			$template->touchBlock('msg_is_sent');
		}
	}
	elseif ($_GET['action'] == 'delete_admin' && !empty($_GET['member_id']))
	{
		if ($group->userIsAdmin($user->UserID))
		{
			$member_id = $_GET['member_id'];
			$group->removeUserFromGroupAdminList($member_id);
		}
		else
		{
			cmn_unauthorized_action();
		}
	}

	$sort_by = ($_GET['sort_by'] == 'UserStatus') ? $_GET['sort_by'] : 'UserName';
	$sort_order = isset($_GET['sort_order']) ? $_GET['sort_order'] : 'ASC';

	// pending group members
	$group_members = $group->getGroupPendingUsers($sort_by, $sort_order);
	foreach ($group_members as $key => $group_member)
	{
		$data['UserID'][$key] = $group_member->UserID;

		$template->setVariable(array(
			'MemberID' => $data['UserID'][$key],
			'MemberName' => db_get_entity_display_name($group_member),
		));
		$template->parse('group_pending_member');
	}

	// group single members
	$group_members = $group->getGroupSingleUsers($sort_by, $sort_order);
	foreach ($group_members as $key => $group_member)
	{
		$data['UserID'][$key] = $group_member->UserID;

		$color = $group->userIsAdmin($data['UserID'][$key]) ? 'yellow' : 'blue';

		if ($group->userIsAdmin($data['UserID'][$key]))
		{
			$template->setVariable(array(
				'MemberID' => $data['UserID'][$key],
				'GroupID' => $group_id,
			));
			$template->parse('group_admin_delete');
		}

		$group_member_status = $group->getUserStatusInGroup($data['UserID'][$key]);

		$template->setVariable(array(
			'MemberID' => $data['UserID'][$key],
			'MemberName' => $group_member->UserFirstname . ' ' . $group_member->UserLastname,
			'MemberColor' => $color,
			'active' => MEMBER_STATUS_ACTIVE,
			'suspend' => MEMBER_STATUS_SUSPEND,
			'blocked' => MEMBER_STATUS_BLOCKED,
			'group_member_active_status_selected' => ($group_member_status == MEMBER_STATUS_ACTIVE) ? 'selected' : '',
			'group_member_suspend_status_selected' => ($group_member_status == MEMBER_STATUS_SUSPEND) ? 'selected' : '',
			'group_member_blocked_status_selected' => ($group_member_status == MEMBER_STATUS_BLOCKED) ? 'selected' : '',
		));
		$template->parse('group_member');
	}

	$template->setVariable($data);


	$subgroups = $group->getSubgroups($sort_by, $sort_order);

	foreach ($group_teams as $key => $group_team)
	{
		$group_team_members = $group_team->getGroupTeamUsers();
		$team_members_string = '0';

		foreach ($group_team_members as $key => $group_team_member)
		{
			$team_user_id = $group_team_member->UserID;

			if ($group->userIsAdmin($team_user_id))
			{
				$template->setVariable(array(
					'TeamMemberID' => $team_user_id,
					'GroupID' => $group_id,
				));
				$template->parse('admin_delete');
			}

			$color = $group->userIsAdmin($team_user_id) ? 'yellow' : 'blue';
			$team_member_status = $group->getUserStatusInGroup($team_user_id);
			$team_members_string .= ', ' . $team_user_id;

			$template->setVariable(array(
				'TeamMemberID' => $team_user_id,
				'TeamMemberName' => $group_team_member->UserFirstname . " " . $group_team_member->UserLastname,
				'TeamMemberColor' => $color,
				'active' => MEMBER_STATUS_ACTIVE,
				'suspend' => MEMBER_STATUS_SUSPEND,
				'blocked' => MEMBER_STATUS_BLOCKED,
				'team_member_active_status_selected' => ($team_member_status == MEMBER_STATUS_ACTIVE) ? 'selected' : '',
				'team_member_suspend_status_selected' => ($team_member_status == MEMBER_STATUS_SUSPEND) ? 'selected' : '',
				'team_member_blocked_status_selected' => ($team_member_status == MEMBER_STATUS_BLOCKED) ? 'selected' : '',
			));
			$template->parse('group_team_member');
		}

		$team_id = $group_team->TeamID;

		$template->setVariable(array(
			'TeamID' => $team_id,
			'TeamName' => $group_team->TeamName,
			'TeamMembers' => $team_members_string,
		));
		$template->parse('group_team');

		$template->setVariable(array(
			'AddTeamID' => $team_id,
			'AddTeamName' => $group_team->TeamName,
		));
		$template->parse('add_team');
	}

	$members = $group->getGroupUsers();

	$xls_data = array();
	foreach ($members as $member)
	{
		$member_id = $member->UserID;
		$member_email = $member->UserEmail;
		$member_title = $member->UserTitle;
		$team = Team::getUserTeamInGroup($member_id, $group_id);
		$team_name = $team->TeamName;

		$xls_data[$member_id] = array(
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['MEMBER_EMAIL'] => $member_email,
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['MEMBER_TITLE'] => $member_title,
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['TEAM_AFFILIATION'] => $team_name,
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_PRODUCTS'] => '',
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_CALENDAR_ENTRIES'] => '',
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_DISCUSSION_BOARDS'] => '',
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_FILES'] => '',
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_PHOTOS_VIDEOS'] => '',
			$EXCEL_MEMBER_SHEET_COLUMN_NAMES['PERMISSION_MILESTONES_TODOS'] => '',
		);
	}

	$export_file = '/xls/grp' . md5($group->GroupID) . '.xls';
	$fp = fopen(DOWNLOAD_MEMBER_EXCEL_SHEET_FILEPATH . $export_file, "wb");

	fwrite($fp, serialize($xls_data));
	fclose($fp);

	$template->setVariable('excel_sheet_filepath', '.' . $export_file);

	$sort_order = ($sort_order == 'ASC') ? 'DESC' : 'ASC';
	$template->setVariable('GroupID', $group_id);
	$template->setVariable('sort_order', $sort_order);
}

manage_members();

include('includes/application_bottom.php');