<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

    $groupid = -1;
    $group = new Group($groupid);

    $organization_id = $_GET['organization_id'];

    if ( ($group->GroupID != -1) && ($group->getOwnerID() != $user->UserID) )
    {
    	//cmn_unauthorized_action();
    }

    // filling data array
    $data = $group->getDataArray();
    $data['GroupID'] = $group->GroupID;
    $data['GroupOwner'] = $user->UserID;
    $data['LocationCountry'] = array();
    $data['LocationName'] = array();
    $data['LocationStreet'] = array();
    $data['LocationCity'] = array();
    $data['LocationState'] = array();

    if (isset($_POST['submitted']))
    {
        $error = false;
        foreach ($data as $key => $field)
        {
            if (isset($_POST[$key]))
            {
                $data[$key] = $_POST[$key];
            }

            switch ($key)
            {
                case "GroupName":
                    if ( ($data[$key] == '') || (Group::nameExists($data[$key])) )
                    {
                        $error = true;
                        $template->touchBlock("err_" . $key);
                    }
                    break;
                case "GroupDescription":
                    if ($data[$key] == '')
                    {
                        $error = true;
                        $template->touchBlock("err_" . $key);
                    }
                    break;
            }
        }

        $group->populateFromArray($data);

        if (!$error)
        {
            $template->touchBlock("success");
            $group->saveToDB();
            $group->setOwner($user->UserID);
            $data['GroupID'] = $group->GroupID;

            if ($organization_id)
            {
            	$group->connectToOrganization($organization_id);
            }

            if (count($_POST['LocationName']) > 0)
            {
				Location::clearGroupLocations($group->GroupID);
				for ($i = 0; $i < count($data['LocationName']); $i++)
				{
					$location = new Location();
					$location->GroupID				= $group->GroupID;
					$location->LocationCountry		= $data['LocationCountry'][$i];
					$location->LocationName			= $data['LocationName'][$i];
					$location->LocationStreet		= $data['LocationStreet'][$i];
					$location->LocationCity			= $data['LocationCity'][$i];
					$location->LocationState		= $data['LocationState'][$i];
					$location->saveToDB();
				}
			}

			if (!is_array($_POST['UserID']))
			{
			    $_POST['UserID'] = array();
			}

			foreach ($_POST['UserID'] as $key => $value)
			{
				$invitation = new Invitation();
				$invitation->GroupID = $group->GroupID;
				$invitation->FromUserID = $user->UserID;
				$invitation->ToUserID = $key;
				$invitation->InvitationPermissions = CONNECTIONTYPE_ADMIN;

				$messageText = 'Please join my group as administrator.';				
				Message::sendGroupAdminInvite($user->UserID, $key, $group->GroupID, $messageText);
			}

			if (isset($_POST['NewMember']))
			{
				$message_text = 'Please join my group.';
				foreach ($_POST['NewMember'] as $member_id)
				{
					$group->inviteMember($user->UserID, $member_id, $message_text);
				}
			}

			// wiki
			wiki_add_group($group);

			// discussion board
            $group->GroupForumID = forum_insertforum($group->GroupName, 6);
            $group->saveToDB();

			ApplicationContext::save();
            $_SESSION['groupdata']['GroupName'] = $group->GroupName;
			cmn_redirect("group_forum_creation.php?group_id=" . $group->GroupID);
			
            if (isset($_SESSION['connect_group_users']))
            {
            	if (isset($_SESSION['connect_group_users']['UserID']))
            	{
            		foreach ($_SESSION['connect_group_users']['UserID'] as $userID)
            		{
            			Message::sendGroupInvite($user->UserID, $group->GroupID, $userID);
            		}
            		cmn_redirect('group_profile.php?group_id=' . $group->GroupID);
				}
				else if (isset($_SESSION['connect_group_users']['OrganizationID']))
				{
					$parentOrg = new Organization($_SESSION['connect_group_users']['OrganizationID']);
            		$parentOrg->addGroup($group->GroupID);

            		unset($_SESSION['connect_group_users']); 
            		cmn_redirect('organization_manage_groups.php?organization_id=' . $parentOrg->OrganizationID);
				}
				else
				{                         
            		$parentGroup = new Group($_SESSION['connect_group_users']['GroupID']);
            		$parentGroup->addGroup($group->GroupID);
            		
            		unset($_SESSION['connect_group_users']); 
            		cmn_redirect('group_manage_groups.php?group_id=' . $parentGroup->GroupID);
				}
            }
            else
            {
            	cmn_redirect('group_profile.php?group_id=' . $group->GroupID);                            
			}

			exit();
        }
    }	// if (isset($_POST['submitted']))
    elseif (is_array($_POST['UserID']))
    {
    	foreach ($_POST['UserID'] as $member_id)
    	{
    		$template->setVariable('NewMemberID', $member_id);
    		$template->parse('new_member');
    	}
    }

    foreach ($COUNTRIES as $key => $value)
	{
		$template->setVariable('key', $key);
		$template->setVariable('value', $value);
		$template->parse('country');
	}

	foreach($STATES as $key => $value )
	{
		$template->setVariable('key', $key);
		$template->setVariable('value', $value);
		$template->parse('state');
	}

	// template setup
	$template->setVariable(array_slice($data, 0, 5)); // text variables

	for ($i = 0; $i < count($data['LocationName']); $i++)
	{
		$template->setVariable('LocationCountry',	$data['LocationCountry'][$i]);
		$template->setVariable('LocationName',		$data['LocationName'][$i]);
		$template->setVariable('LocationStreet',	$data['LocationStreet'][$i]);
		$template->setVariable('LocationCity',		$data['LocationCity'][$i]);
		$template->setVariable('LocationState',		$data['LocationState'][$i]);
		$template->parse("location");
	}
include('includes/application_bottom.php');