<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class DBConnect
{
	public static $dbConnect = null;
	private $link = null;

	public function getLink()
	{
	    return $this->link;
	}

	public static function getInstance()
	{
		if (is_null(DBConnect::$dbConnect))
		{
			DBConnect::$dbConnect = new DBConnect();
		}
		return DBConnect::$dbConnect;
	}

	private function __construct()
	{
        $this->connect();
	}

    private function connect()
    {
        $this->link = mysql_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD);

        if (!mysql_select_db(DB_DATABASE, $this->link))
        {
            echo 'db error: ' . mysql_error();
            exit;
        }

        mysql_query("SET NAMES utf8;", $this->link);

        mysql_query("set character_set_results=utf8;",    $this->link);
        mysql_query("set character_set_connection=utf8;", $this->link);
        mysql_query("set character_set_client=utf8;",     $this->link);
        mysql_query("set character_set_database=utf8;",   $this->link);    
    }
	public function directQuery($query)
	{
		return new QueryResult($query, $this->link);
	}

	public function query($query)
	{
		try
        {
            $obj = new QueryResult(DBConnect::prepare_query(func_get_args()), $this->link, 1, 0);
        }
        catch (Exception $ex)
        {
            $this->connect();
            $obj = new QueryResult(DBConnect::prepare_query(func_get_args()), $this->link, 1, 0);
        }
        
		//var_dump($obj);
        
		return $obj;
	}

	public function pageQuery($page, $pageSize, $query)
	{
		return new QueryResult(DBConnect::prepare_query(array_slice(func_get_args(), 2)),
			$this->link, $page, $pageSize);
	}
	/*
	private static function prepare_query($args)
	{
		$return = '';
		if (($argsCount = count($args)) > 0)
		{
			$eval = 'return sprintf($args[0]';
			for ($i = 1; $i < $argsCount; $i++)
			{
				$eval .= ', ud_sanitize_db($args[' . $i . '])';
			}
			$eval .= ');';

			$return = eval($eval);
		}
		return $return;
	}
	*/

	private static function prepare_query($args)
	{
		$return = '';
		if (($argsCount = count($args)) > 0)
		{
			preg_match_all('/(?:[^\%])(\%(?:t|f|p|s|d)+)/', $args[0], $types);

			$args[0] = preg_replace('/([^\%])?\%(?:t|f|p)+/', '\1%s', $args[0]);

			$types	 = $types[1];

			// added for use an array as the second argument - for example, if we don't know, how much arguments will we send
			// nikita: good idea!

			if (is_array($args[1]))
			{
				foreach ($args[1] as $arg)
				{
					$args[] = $arg;
				}

				array_splice($args, 1, 1);
				$argsCount = count($args);
			}

			/*
			$argsline = array();
			for ($i = 1; $i < $argsCount; $i++)
			{
				if (is_array($args[$i]))
				{
					foreach ($args[$i] as $arg)
					{
						$argsline[$i] = $arg;      <==== will write only last array value - fixed above (nikita)
					}
				}
				else
				{
					$argsline[$i] = $args[$i];
				}
			}
			$arg0 = $args[0];
			$args = $argsline;
			$args[0] = $arg0;
			$argsCount = count($args);

			//it is temp version - will be rewritten if approved
			*/

			$eval = 'return sprintf($args[0]';
			for ($i = 1; $i < $argsCount; $i++)
			{
				switch ($types[$i - 1])
				{
						case '%':
							echo 'a'; // todo
							break;

						case '%s':
							$separator = '\\\'';
							break;
						case '%p':
							$separator = '\\\'';
							$args[$i] = '%' . $args[$i] . '%';
							break;
						case '%f':
						case '%t':
							$separator = '`';
							break;

						default:
						case '%n':
							$separator = '';
				}
				/*
                if ($$this->Filter)
                {
                */
                    $eval .= ', \'' . $separator . '\' . ud_sanitize_db($args[' . $i . ']) . \'' . $separator . '\'';
                    /*
                }
                else
                {
                    $eval .= ', \'' . $separator . '\' . $args[' . $i . '] . \'' . $separator . '\'';
                }
                */

			}
			$eval .= ');';
			$return = eval($eval);

		}

		return $return;
	}


	public function insert($table, $data)
	{
		//print_r($data);
		//die();

		$id = -1;
		$sql = 'INSERT INTO `' . $table . '` (' . implode(',', array_keys($data)) .
			') VALUES (' . implode(',', DBConnect::prepare_db_values(array_values($data))) . ')';

		//print $sql;
		//die();

		if ($rs = mysql_query($sql, $this->link))
		{
			$id = mysql_insert_id($this->link);
			//printf(mysql_affected_rows($this->link));
		}
		else
		{
			//echo mysql_error($this->link);
			throw new Exception(mysql_error($this->link));
		}
		return $id;
	}

	public function update($table, $data, $parameters)
	{
		$keys	= array_keys($data);
		$values = DBConnect::prepare_db_values(array_values($data));

		$query = 'UPDATE `' . $table . '` SET ';

		for ($i = 0; $i < count($data); $i++)
			$query .= ($i ? ', ' : '') . $keys[$i] . ' = ' . $values[$i];

		//print $query . ' WHERE ' . DBConnect::prepare_query(array_slice(func_get_args(), 2));
		//die();

		$result = mysql_query($query . ' WHERE ' . DBConnect::prepare_query(array_slice(func_get_args(), 2)));
		if (!$result)
		{
			throw new Exception(mysql_error($this->link));
		}

		return $result;
	}

	public function delete($table, $parameters)
	{
		mysql_query('DELETE FROM `' . $table . '` WHERE ' . DBConnect::prepare_query(array_slice(func_get_args(), 1)), $this->link);
		return !mysql_errno($this->link);
	}

	private static function prepare_db_values($data_values)
	{
		$values = array();
		foreach ($data_values as $value)
		{

			switch ((string)$value)
			{
				case 'now()':
					$values[] = 'now()';
					break;

				case '':
				case 'null':
					if ($value === false)
					{
						$values[] = 0;
					}
					else
					{
						$values[] = 'null';
					}
					break;

				default:
					$values[] = '\'' . ud_sanitize_db($value) . '\'';
					break;
			}
		}
		return $values;
	}

	/**
	* Emulate the lastInsertId method from phplib
	*
	* @access public
	* @param string     fieldname  The database fieldname to
	*                              generate a new id for
	* @return integer
	*/
	function lastInsertId()
	{
		$result = mysql_query("SELECT LAST_INSERT_ID()");

		return mysql_result($result, 0);
	}
}
?>