<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class GMailer
{
    function getAddressbook($user, $pass)
    {
        // Parameters for ClientLogin authentication
        Zend_Loader::loadClass('Zend_Gdata_ClientLogin');
        Zend_Loader::loadClass('Zend_Gdata_Gbase');

        // Create an authenticated HTTP client
        try
        {
            $client = Zend_Gdata_ClientLogin::getHttpClient($user . '@gmail.com', $pass, 'cp');
        }
        catch (Exception $ex)
        {
            return false;
        }
        
        $gdata = new Zend_Gdata($client); 
        
        $query = new Zend_Gdata_Query('http://www.google.com/m8/feeds/contacts/default/base'); 
        $query->setMaxResults(10000); 
        $return = array('name' => array(), 'email' => array());
        $feed = $gdata->retrieveAllEntriesForFeed($gdata->getFeed($query)); 
        foreach ($feed as $entry) 
        { 
            
            $return['name'][] = $entry->title->text; 
            $ext = $entry->getExtensionElements(); 
            foreach ($ext as $extension) 
            { 
                if ($extension->rootElement == "email") 
                { 
                    $attr=$extension->getExtensionAttributes(); 
                    $return['email'][] = $attr['address']['value']; 
                    break;
                } 
            } 
        }
        return $return;
    }
}

?>
