<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


class Entity
{
	public function __construct($entity_id = -1)
	{
		if ($entity_id != -1 && !empty($entity_id))
		{
			$db = DBConnect::getInstance();
			$res = $db->query('select * from %t where %f = %d', db_get_table_name($this), db_get_entity_key($this), $entity_id);

			if ($res->Size > 0)
			{
				$this->populateFromArray($res->Data[0]);
			}
		}
	}

    public static function getObject($entity = 'Entity', $id = -1)
    {
    	$entity = ucfirst($entity);

        if (@is_subclass_of($entity, 'Entity'))
        {
            return new $entity($id);
        }
        else
        {
            return new Entity();
        }

    }


	public function populateFromArray($data)
	{
		foreach ($data as $field => $value)
		{
			if (property_exists($this, $field))
			{
				if(is_string($value))
				{
					$this->{$field} = 	$data = htmlentities($value, ENT_NOQUOTES);
				}
			}
		}

	}


	public function getDataArray()
	{
		$data = array();
		foreach (get_class_vars(get_class($this)) as $key => $value)
		{
			if ($key != db_get_entity_key($this))
				$data[$key] = $this->{$key};
		}
		return $data;
	}

	protected function updateInDB($data)
	{
		$db			= DBConnect::getInstance();
		$keyField	= db_get_entity_key($this);

		$db->update(db_get_table_name($this), $data, '%f = %d', $keyField, $this->{$keyField});
	}

	protected function addToDB($data)
	{
		$db = DBConnect::getInstance();
		return $db->insert(db_get_table_name($this), $data);
	}

	public function delete()
	{
		$db			= DBConnect::getInstance();
		$keyField	= db_get_entity_key($this);

		if ($this->{$keyField} != -1)
		{
			$db->delete(db_get_table_name($this), '%f = %d', $keyField, $this->{$keyField});
		}
	}

	public function saveToDB()
	{
		$data		= $this->getDataArray();
		$keyField	= db_get_entity_key($this);





		if ($this->{$keyField} == -1)
		{
			$this->{$keyField} = $this->addToDB($data);
		}
		else
		{
			$this->updateInDB($data);
		}
	}

	public static function getAll($strEntity)
	{
		$return = array();

		if (is_subclass_of($strEntity, 'Entity'))
		{
			$db = DBConnect::getInstance();
			$result = $db->query('select * from ' . strtolower($strEntity));
			foreach ($result->Data as $row)
			{
				$obj = new $strEntity();
				$obj->populateFromArray($row);
				$return[] = $obj;
			}
		}

		return $return;
	}

	public static function existForFieldValue($strEntity, $strField, $value)
	{
		$db = DBConnect::getInstance();
		$sql = 'select count(*) as cnt from ' . strtolower($strEntity) .
		' where ' . $strField . ' = \'' . ud_sanitize($value) . '\'';




		$res = $db->query($sql);
		return ($res->Data[0]['cnt'] > 0);
	}

	public function getEntityObjects()
	{
		$return = array();

		$db = DBConnect::getInstance();
		$res = $db->query('SELECT * FROM `'.strtolower(get_class($this)).'`');

		foreach ($res->Data as $row)
		{
			eval("\$entity = new ".get_class($this)."();");
			$entity->populateFromArray($row);
			$return[] = $entity;
		}

		return $return;
	}

	public function checkActionPermission($action)
	{
	    $result = true;
		return $result;
	}
}