<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Form Extends Entity
{
	public $FormID			= -1;
	public $GroupID 		= -1;
	public $OrganizationID 	= -1;
	public $FormName		= '';
	public $FormDescription	= '';
	public $FormStatus		= FORM_STATUS_ACTIVE;
	public $FormStartDate	= CURRENT_TIME;
	public $FormEndDate		= CURRENT_TIME;
	public $FormPrivacy		= PRIVACY_PUBLIC;


    public function getOwner()
    {
        if ($this->OrganizationID != -1)
        {
            $result = new Organization($this->OrganizationID);
        }
        elseif ($this->GroupID != -1)
        {
            $result = new Group($this->GroupID);
        }
        else
        {
        	$result = new Group(-1);
		}

        return $result;
    }

    public static function getGroupForms($group_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM `form` WHERE GroupID = %d', $group_id);
        foreach ($query->Data as $row)
        {
            $file = new Form();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public static function getOrganizationForms($organization_id)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $query = $db->query('SELECT * FROM `form` WHERE OrganizationID = %d', $organization_id);
        foreach ($query->Data as $row)
        {
            $file = new Form();
            $file->populateFromArray($row);
            $result[] = $file;
        }

        return $result;
    }

    public function getFormFields()
    {
    	return FormField::getFormFields($this->FormID);
	}

	public function delete()
	{
		$fields = FormField::getFormFields($this->FormID);
		foreach ($fields as $field)
		{
			$field->delete();
		}
		parent::delete();
	}
}
?>