<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Session extends Entity
{
	public $SessionID	= -1;
	public $UserID		= -1;
	public $Created		= CURRENT_TIME;
	public $UserOnlineStatus	= USER_ONLINE_STATUS_ONLINE;
	public $UserOnlineStatusOther	= "";
	public $UserAwayMessage	= "";


	public function __construct($id = -1)
	{
		parent::__construct($id);
	}

	protected function addToDB($data)
	{
		$db = DBConnect::getInstance();
		$db->delete('session', 'UserID = ' . $this->UserID);
		return parent::addToDB($data);
	}

	//
	public static function isUserLoggedIn($user_id)
	{
		$user = new User($user_id);
		$db = DBConnect::getInstance();
		$res = $db->query("SELECT COUNT(*) AS cnt FROM session WHERE UserId = %s", $user->UserID);
		return ($res->Data[0]['cnt'] > 0);
	}

	public static function isCurrentSessionLoggedIn()
	{
		if (!isset($_SESSION['sessionid']) && !isset($_COOKIE['sessionid']))
		{
			$result = false;
		}
		else
		{
			$sessionId = isset($_COOKIE['sessionid']) ? $_COOKIE['sessionid'] : $_SESSION['sessionid'];
			$db = DBConnect::getInstance();
			$res = $db->query("SELECT COUNT(*) AS cnt FROM session WHERE SessionID = %d", $sessionId);
			$result = ($res->Data[0]['cnt'] > 0);
			if (!$result)
			{
			    setcookie("sessionid", '');
			}

		}
		return $result;
	}

	public function loginUser(User $user)
	{
		if ($user->UserID != -1)
		{
			$this->UserID = $user->UserID;
			$this->saveToDB();
		}
	}

	public function getUserSession($user_id)
	{
		$return = new Session();
		$user = new User($user_id);
		if ($user->UserID != -1)
		{
			$db = DBConnect::getInstance();
			$res = $db->query("SELECT * FROM `session` WHERE UserId = %s", $user->UserID);

			if ($res->Size > 0)
			{
				$return->populateFromArray($res->Data[0]);
			}
			return $return;
		}
	}

	public static function updateUserOnlineStatus($user_id, $online_status, $online_status_other, $away_msg)
	{
		$db = DBConnect::getInstance();
		$db->update('session', array('UserOnlineStatus' => $online_status), 'UserId = ' . $user_id);
		if ($online_status == USER_ONLINE_STATUS_OTHER)
		{
			$db->update('session', array('UserOnlineStatusOther' => $online_status_other), 'UserId = ' . $user_id);
		}
		else if ($online_status == USER_ONLINE_STATUS_AWAY)
		{
			$db->update('session', array('UserAwayMessage' => $away_msg), 'UserId = ' . $user_id);
		}
	}
}