<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Tag extends Entity
{
	public $TagID		= -1;
	public $ObjectID	= -1;
	public $TagName		= "";
	public $UserID		= -1;
	public $GroupID		= -1;
	public $OrganizationID	= -1;
	public $CommunityID	= -1;
	public $TagKeywords	= -1;
	public $TagType		= 0;
	public $TagConnectionPrivacyFlag = TAG_PRIVACY_PUBLIC;
	public $TagUserPrivacyStatus	= 0;
	public $TagGroupPrivacyStatus	= 0;
	public $TagOrganizationPrivacyStatus	= 0;


	public static function acceptUserTag($tag_id)
	{
		$db = DBConnect::getInstance();
		$db->update('tag', array('TagUserPrivacyStatus' => TAG_STATUS_ACCEPTED), 'TagID = ' . $tag_id);
	}

	public static function acceptGroupTag($tag_id)
	{
		$db = DBConnect::getInstance();
		$db->update('tag', array('TagGroupPrivacyStatus' => TAG_STATUS_ACCEPTED), 'TagID = ' . $tag_id);
	}

	public static function acceptOrganizationTag($tag_id)
	{
		$db = DBConnect::getInstance();
		$db->update('tag', array('TagOrganizationPrivacyStatus' => TAG_STATUS_ACCEPTED), 'TagID = ' . $tag_id);
	}

	public static function allowOrganizationMembersToViewThisTag($organization_id, $tag_id)
	{
		$db = DBConnect::getInstance();
		$db->insert('tagprivacyconnection', array('TagID' => $tag_id, 'UserID' => -1, 'GroupID' => -1, 'OrganizationID' => $organization_id, 'PrivacyFlag' => PRIVACY_FLAG_TAG_SET));
	}

	public static function allowGroupMembersToViewThisTag($group_id, $tag_id)
	{
		$db = DBConnect::getInstance();
		$db->insert('tagprivacyconnection', array('TagID' => $tag_id, 'UserID' => -1, 'GroupID' => $group_id, 'OrganizationID' => -1, 'PrivacyFlag' => PRIVACY_FLAG_TAG_SET));
	}

	public static function allowUserToViewThisTag($user_id, $tag_id)
	{
		$db = DBConnect::getInstance();
		$db->insert('tagprivacyconnection', array('TagID' => $tag_id, 'UserID' => $user_id, 'GroupID' => -1, 'OrganizationID' => -1, 'PrivacyFlag' => PRIVACY_FLAG_TAG_SET));
	}

	public static function togglePrivacyFlagState($tag_id, $state)
	{
		$db = DBConnect::getInstance();
		$db->update('tag', array('TagConnectionPrivacyFlag' => $state), 'TagID=%d', $tag_id);
	}

    public static function getUserTags($user_id, $tag_type = 0, $object_id = 0)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $clause = $tag_type ? " AND TagType=". $tag_type : "";
        $clause .= $object_id ? " AND ObjectID=". $object_id : "";
        $query = $db->query("SELECT * FROM `tag` WHERE UserID = %d" . $clause, $user_id);
        foreach ($query->Data as $row)
        {
            $tag = new Tag();
            $tag->populateFromArray($row);
            $result[] = $tag;
        }

        return $result;
    }

    public static function getGroupTags($group_id, $tag_type = 0, $object_id = 0)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $clause = $tag_type ? " AND TagType=". $tag_type : "";
        $clause .= $object_id ? " AND ObjectID=". $object_id : "";
        $query = $db->query("SELECT * FROM `tag` WHERE GroupID = %d" . $clause, $group_id);
        foreach ($query->Data as $row)
        {
            $tag = new Tag();
            $tag->populateFromArray($row);
            $result[] = $tag;
        }

        return $result;
    }

    public static function getOrganizationTags($organization_id, $tag_type = 0, $object_id = 0)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $clause = $tag_type ? " AND TagType=". $tag_type : "";
        $clause .= $object_id ? " AND ObjectID=". $object_id : "";
        $query = $db->query("SELECT * FROM `tag` WHERE OrganizationID = %d" . $clause, $organization_id);
        foreach ($query->Data as $row)
        {
            $tag = new Tag();
            $tag->populateFromArray($row);
            $result[] = $tag;
        }

        return $result;
    }

    public static function getTags($tag_type = 0, $object_id = 0)
    {
        $result = array();

        $db = DBConnect::getInstance();
        $clause = $tag_type ? " WHERE TagType=". $tag_type : "";
        $clause .= $object_id ? " AND ObjectID=". $object_id : "";
        $query = $db->query("SELECT * FROM `tag`" . $clause);
        foreach ($query->Data as $row)
        {
            $tag = new Tag();
            $tag->populateFromArray($row);
            $result[] = $tag;
        }

        return $result;
    }

    public function getLocations()
    {
    	return TagLocation::getTagLocations($this->TagID);
    }
}