<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class Todo extends Entity
{
	public $TodoID			= -1;
	public $GroupID			= -1;
	public $OrganizationID	= -1;
	public $UserID			= -1;
	public $TodoName		= '';
	public $TodoDescription	= '';
	public $TodoStatus		= TODO_STATUS_IN_PROGRESS;


	public static function getGroupTodos($group_id)
	{
		$result = array();

		$db = DBConnect::getInstance();
		$query = 'SELECT * FROM `todo` WHERE GroupID = %d ORDER BY TodoID';

		$query_result = $db->query($query, $group_id);

		foreach ($query_result->Data as $key => $row)
		{
			$todo = new Todo();
			$todo->populateFromArray($row);
			$result[] = $todo;
		}

		return $result;
	}

	public static function getOrganizationTodos($organization_id)
	{
		$result = array();

		$db = DBConnect::getInstance();
		$query = 'SELECT * FROM `todo` WHERE OrganizationID = %d ORDER BY TodoID';

		$query_result = $db->query($query, $organization_id);

		foreach ($query_result->Data as $key => $row)
		{
			$todo = new Todo();
			$todo->populateFromArray($row);
			$result[] = $todo;
		}

		return $result;
	}

	public static function clearGroupTodos($group_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('todo', 'GroupID = %d', $group_id);
	}

	public static function clearOrganizationTodos($organization_id)
	{
		$db = DBConnect::getInstance();
		$db->delete('todo', 'OrganizationID = %d', $organization_id);
	}

	public static function getAssignedToUserTodosCount($user_id)
	{
		$result = 0;

		$db = DBConnect::getInstance();
		$query = 'SELECT COUNT(*) AS cnt FROM `todo` WHERE UserID = %d ORDER BY TodoID';

		$query_result = $db->query($query, $user_id);

		return $query_result->Data[0]['cnt'];
	}
}
?>