<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class User extends ConnectionEntity
{
	public $UserID			= -1;
	public $UserType		= USER_TYPE_MEMBER;
	public $Username		= "";
	public $Password		= "";
	public $UserFirstname	= "";
	public $UserLastname	= "";
	public $UserTitle		= "";
	public $UserEmail		= "";
	public $UserAddress1	= "";
	public $UserAddress2	= "";
	public $UserCity		= "";
	public $UserZip			= "";
	public $UserState		= "";
	public $UserCountry		= "";
	public $UserPhone		= "";
	public $UserMobilePhone	= "";
	public $UserFax	= "";
	public $UserPicture		= "";
	public $UserInterests	= "";
	public $UserInterestsOther = "";

	public $UserFavouriteMovies		= "";
	public $UserFavouriteBooks		= "";
	public $UserFavouriteFood		= "";
	public $UserFavouriteInterests	= "";
	public $UserFavouriteActivities	= "";
	public $UserFavouriteWebsites	= "";
	public $UserResume           	= "";
	public $UserRegistrationDate	= CURRENT_TIME;
	public $UserFavoritesPrivacy	= "";
	public $UserEducationPrivacy	= "";
	public $UserWorkPrivacy			= "";
	public $UserJobPrivacy			= "";
	public $UserStatus				= USER_STATUS_ACTIVE;
    public $UserMessagingCredit		= 0.00;

	public $UserYahoo		= "";
	public $UserSkype		= "";
	public $UserMSN			= "";
	public $UserAOL			= "";

	public $OnlyMyFlags		= PRIVACY_FLAGS_NONE;	// account privacy

	public $UserCalendarPrivacy		= CALENDAR_PRIVACY_PUBLIC;

	public $UserUpdated				= '';
	public $UserForumID 			= -1;
	public $UserPermissions			= 0;
	public $UserStorage				= 1073741824;
	public $UserStorageExpDate		= '';


	// special stub: nobody is admin of user except user is admin of his own
	public function userIsAdmin($user_id)
    {
    	return ($user_id == $this->UserID);
    }

	// special stub: nobody is member of user except user is member of himself
	public function hasMember($user_id)
    {
    	return ($user_id == $this->UserID);
    }

	// special stub: user is the only member of his own
	public function getMembers()
    {
    	return array($this);
    }

	// special stub: nobody is target of user except user is target of himself
	public function getTarget()
    {
    	return $this;
    }

	// special stub: nobody is owner of user except user is owner of his own
	public function getOwnerID()
    {
    	return $this->UserID;
    }

	public function getSentInvitationCountRank()
    {
        return SentInvitation::getUserSentInvitationCountRank($this->UserID);
    }

    public function getSentInvitationCount()
    {
        return SentInvitation::getUserSentInvitationCount($this->UserID);
    }

    public function getVideoCountRank()
    {
        return Video::getUserVideoCountRank($this->UserID);
    }

    public function getVideoCount()
    {
        return Video::getUserVideoCount($this->UserID);
    }

    public function getPhotoCountRank()
    {
        return Photo::getUserPhotoCountRank($this->UserID);
    }

    public function getPhotoCount()
    {
        return Photo::getUserPhotoCount($this->UserID);
    }

	public function checkCalendarPrivacy($userID)
	{
		$blnCanSee = true;

		if ($this->UserCalendarPrivacy != CALENDAR_PRIVACY_PUBLIC)
		{
			$blnCanSee = $this->UserID == $userID;

			if ($this->UserCalendarPrivacy == CALENDAR_PRIVACY_PROTECTED)
			{
				$blnCanSee = $blnCanSee || Connection::checkCalendarPrivacy('User', $this->UserID, $userID);
			}
		}

		return $blnCanSee;
	}

	public function addBuddy($userID)
	{
		$connection = new Connection();
		$connection->ConnectionType = CONNECTIONTYPE_BUDDY;
		$connection->UserID = $this->UserID;
		$connection->ToUserID = $userID;
		$connection->saveToDB();

		$connection = new Connection();
		$connection->ConnectionType = CONNECTIONTYPE_BUDDY;
		$connection->UserID = $userID;
		$connection->ToUserID = $this->UserID;
		$connection->saveToDB();

		$connection = new Connection();
		$connection->ConnectionType = CONNECTIONTYPE_PRIVACY;
		$connection->UserID = $this->UserID;
		$connection->ToUserID = $userID;
		$connection->PrivacyFlags = PRIVACY_FLAGS_ALL;
		$connection->saveToDB();

		$connection = new Connection();
		$connection->ConnectionType = CONNECTIONTYPE_PRIVACY;
		$connection->UserID = $userID;
		$connection->ToUserID = $this->UserID;
		$connection->PrivacyFlags = PRIVACY_FLAGS_ALL;
		$connection->saveToDB();
	}
	public function getConnectedUsers($name_constraint = '')
	{
		return Connection::getConnectedUsers($this->UserID, $name_constraint);
	}

    public function getConnectedGroups($name_constraint = '')
    {
        return Connection::getConnectedGroups($this->UserID, $name_constraint);
    }

    public function getConnectedOrganizations($name_constraint = '')
    {
        return Connection::getConnectedOrganizations($this->UserID, $name_constraint);
    }

    public function getConnectedCommunities($name_constraint = '')
    {
        return Connection::getConnectedCommunities($this->UserID, $name_constraint);
    }

	public function getBuddies()
	{
		$connections = Connection::getUserBuddyConnections($this->UserID);
		$return = array();

		foreach ($connections as $connection)
		{
			$return[] = $connection->getTarget($this);
		}
		return $return;
	}

	public function hasBuddy($userID)
	{
		return $this->isBuddy($userID);
	}

	public function isBuddy($userID)
	{
		$result = true;

		if ($userID != $this->UserID)
		{
			$conns = Connection::getConnections
			(
				array
				(
					'UserID'		 => array($this->UserID, $userID),
					'ToUserID'		 => array($this->UserID, $userID),
					'ConnectionType' => CONNECTIONTYPE_BUDDY
				)
			);

			$result = (count($conns) > 0);
		}

		return $result;
	}

	public function getOrders()
	{
		return Order::getUserOrders($this->UserID);
	}

	public function removeBuddy($userID)
	{
		$conns = Connection::getConnections
		(
			array
			(
				'UserID'		 => array($this->UserID, $userID),
				'ToUserID'		 => array($this->UserID, $userID),
				'ConnectionType' => CONNECTIONTYPE_BUDDY
			)
		);

		foreach ($conns as $connection)
		{
			$connection->delete();
		}
	}

	public function getOwnEvents()
	{
		return Event::getUserOwnEvents($this->UserID);
	}


	public function sendGroupRequest($groupID, $messageText)
	{
		Message::sendGroupRequest('User', $this->UserID, $groupID, $messageText);
	}

	public function sendOrganizationRequest($orgID, $messageText, $type = 0)
	{
		Message::sendOrganizationRequest('User', $this->UserID, $orgID, $messageText);
	}

    public function sendBuddyRequest($userID, $messageText)
	{
		return Message::sendBuddyRequest($this->UserID, $userID, $messageText);
	}

    public function isBuddyRequested($userID)
	{
		return Message::isBuddyRequestSent($this->UserID, $userID);
	}

	// checks rights to view favorites
	public function canSeeFavorites($userid)
    {
        return Connection::checkUserPrivacyAccessPrivilegies(PRIVACY_FLAG_FAVOURITES, $this->UserID, $userid);
    }

    public function canSeeEducation($userid)
    {
        return true;
    }

    public function canSeeWork($userid)
    {
        return true;
    }

    public function canSeeJob($userid)
    {
        return true;
    }

	public static function clearUserSocialGroups()
	{
		$db = DBConnect::getInstance();
		$db->delete('socialgroup', 'UserID = %d', $this->UserID);
	}

	public function getUserSocialGroups()
	{
		return SocialGroup::getUserSocialGroups($this->UserID);
	}

	public function getSkills()
	{
		return Skill::getUserSkills($this->UserID);
	}

    public static function getGroupUsers($groupID)
	{
		$return = array();

    	$db = DBConnect::getInstance();
    	$query =
    		'SELECT u.* FROM `connection` AS c INNER JOIN `group` AS g ON g.GroupID = c.GroupID ' .
    		'INNER JOIN `user` AS u ON u.UserID = c.UserID ' .
    		'WHERE g.GroupID = %d AND u.UserID IS NOT NULL AND (c.ConnectionType = %d OR c.ConnectionType = %d OR c.ConnectionType = %d)';
    	$result = $db->query($query, $groupID, CONNECTIONTYPE_OWNER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER);

    	foreach ($result->Data as $row)
    	{
    		$group_user = new User();
    		$group_user->populateFromArray($row);
    		$return[] = $group_user;
    	}

    	return $return;
	}

	public static function getGroupSingleUsers($group_id, $sort_by = 'UserName', $sort_order = 'ASC')
	{
		$return = array();

    	$db = DBConnect::getInstance();

    	$query = "SELECT DISTINCT u.* FROM `user` AS u
			INNER JOIN `connection` AS c ON c.UserID = u.UserID
			AND (c.GroupID = %d) AND (c.ConnectionType = %d OR c.ConnectionType = %d OR c.ConnectionType = %d)
			AND u.UserID NOT IN
			(
				SELECT u1.UserID FROM `user` AS u1
				INNER JOIN `connection` AS c1 ON c1.UserID = u1.UserID
				INNER JOIN `usertoteam` AS utt1 ON utt1.UserID = u1.UserID
				INNER JOIN `team` AS t1 ON t1.GroupID = c1.GroupID
				AND t1.TeamID = utt1.TeamID
				WHERE (c1.GroupID = %d)
			)
			ORDER BY %f %n";

    	$result = $db->query($query, $group_id, CONNECTIONTYPE_OWNER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_MEMBER, $group_id, $sort_by, $sort_order);

    	foreach ($result->Data as $row)
    	{
    		$group_user = new User();
    		$group_user->populateFromArray($row);
    		$return[] = $group_user;
    	}

    	return $return;
	}

	public static function getGroupTeamUsers($team_id)
	{
		$return = array();

    	$db = DBConnect::getInstance();
    	$query =
    		'SELECT DISTINCT u.* FROM `user` AS u ' .
    		'INNER JOIN `connection` AS c ON c.UserID = u.UserID ' .
    		'INNER JOIN `usertoteam` AS utt ON utt.UserID = u.UserID ' .
    		'INNER JOIN `team` AS t ON t.TeamID = utt.TeamID AND t.GroupID = c.GroupID ' .
    		'WHERE t.TeamID = %d ' .
    		'ORDER BY t.TeamName ASC';
    	$result = $db->query($query, $team_id);

    	foreach ($result->Data as $row)
    	{
    		$group_user = new User();
    		$group_user->populateFromArray($row);
    		$return[] = $group_user;
    	}

    	return $return;
	}


    public function getGroupsNews()
    {
        return News::getUserGroupsNews($this->UserID);
    }

    public function getOrganizationsNews()
    {
        return News::getUserOrganizationsNews($this->UserID);
    }

    public function getCommunitiesNews()
    {
        return News::getUserCommunitiesNews($this->UserID);
	}

    public function getCommunities()
    {
    	return Community::getUserCommunities($this->UserID);
    }

    public function getResumes()
    {
    	return UserResume::getUserResumes($this->UserID);
    }

    public function getComments()
    {
    	return Comment::getUserComments($this->UserID);
    }

    public static function getByUsername($username)
	{
		$user = new User();
		$username = trim($username);
		if ($username != '')
		{
			$db = DBConnect::getInstance();
			$res = $db->query('SELECT * FROM `user` WHERE CONCAT(UserFirstname, CHAR(32), UserLastname) = %s', $username);

			if ($res->Size > 0)
			{
				$user->populateFromArray($res->Data[0]);
			}
		}

		return $user;
	}

	public function getSentInvitations()
	{
		return SentInvitation::getUserSentInvitations($this->UserID);
	}

	public static function getUsersByCompanyName($name)
	{
		$db = DBConnect::getInstance();
		$res = $db->query('select u.* from user u left join company c on u.UserID = c.UserID where c.CompanyName = %s group by u.UserID', $name);
		$return = array();
		foreach ($res->Data as $row)
		{
			$obj = new User();
			$obj->populateFromArray($row);
			$return[] = $obj;
		}
		return $return;
	}

	public static function getUsersBySchoolName($name)
	{
		$db = DBConnect::getInstance();
		$res = $db->query('select u.* from user u left join school s on u.UserID = s.UserID where s.SchoolName = %s group by u.UserID', $name);
		$return = array();
		foreach ($res->Data as $row)
		{
			$obj = new User();
			$obj->populateFromArray($row);
			$return[] = $obj;
		}
		return $return;
	}


	public static function getByUserEmail($userEmail)
	{
		$user = new User();
		$user->UserEmail = $userEmail;

		if ($userEmail != '')
		{
			$db = DBConnect::getInstance();
			$res = $db->query('SELECT * FROM `user` WHERE UserEmail = %s', $userEmail);

			if ($res->Size > 0)
			{
				$user->populateFromArray($res->Data[0]);
			}
		}

		return $user;
	}
	public static function getByUserID($UserID)
	{
		$user = new User();
		$user->UserID = $UserID;

		if ($UserID != '')
		{
			$db = DBConnect::getInstance();
			$res = $db->query('SELECT * FROM `user` WHERE UserID = %d', $UserID);

			if ($res->Size > 0)
			{
				$user->populateFromArray($res->Data[0]);
			}
		}

		return $user;
	}

	public static function getUsers($userType = '')
	{
		$db = DBConnect::getInstance();
		$params = array();
		$query  = 'select * from user';

		if ($userType != '')
		{
			$query .= ' where UserType = %d';
			$params[] = $userType;
		}

		$return = array();
		$result = $db->query($query, $params);
		foreach ($result->Data as $row)
		{
			$user = new User();
			$user->populateFromArray($row);
			$return[] = $user;
		}

		return $return;
	}

	public function sendEventRequest($eventID, $messageText)
	{
		Message::sendEventRequest($this->UserID, $eventID, $messageText);
	}

	public function getFreeSpace()
	{
        if (!empty($this->UserStorageExpDate) && (strtotime($this->UserStorageExpDate) < time()) && ($this->UserStorage > 0))
        {
            $this->UserStorage = 0;
            $this->saveToDB();
        }

        return $this->UserStorage - (Photo::getUserPhotosSize($this->UserID) +
        	Video::getUserVideosSize($this->UserID) + SharedFile::getUserFilesSize($this->UserID));
	}

	public function getConnections($where = array(), $order = array(), $limit = 0)
	{
		$where['UserID'] = $this->UserID;
		return Connection::getConnections($where, $order, $limit);
    }

	public function getBlogEntries()
	{
		return BlogEntry::getUserBlogEntries($this->UserID);
	}

	public function getBlogEntryCount()
	{
		return BlogEntry::getUserBlogEntryCount($this->UserID);
	}

	public function getBlogEntryRank()
    {
        $all = BlogEntry::getAllBlogEntriesCount();
    	return $all ? sprintf("%d", $this->getBlogEntryCount() / $all * 100) : 0;
    }

	public function saveFunctions($arrFunctionsID)
	{
		return FUNCTION_CLASS_NAME::saveUserFunctions($this->UserID, $arrFunctionsID);
	}

	public function getCompanies()
	{
		return Company::getUserCompanies($this->UserID);
	}

	public function getSchools()
	{
		return School::getUserSchools($this->UserID);
	}

	public function getFunctions()
	{
		return FUNCTION_CLASS_NAME::getUserFunctions($this->UserID);
	}

	public static function getAllUsersCount()
	{
		$db = DBConnect::getInstance();
		$query = $db->query("SELECT COUNT(*) AS cnt FROM `user`");
		return $query->Data[0]['cnt'];
	}

	public function getAlbums()
	{
		return Album::getUserAlbums($this->UserID);
	}

    public function getEvents()
    {
        return Event::getUserEvents($this->UserID);
    }

    public function getUpcomingEvents($limit = 0)
    {
        return Event::getUserUpcomingEvents($this->UserID, $limit);
    }

	public static function getUserEmailByID($user_id)
	{
		$db = DBConnect::getInstance();
    	$query = 'SELECT UserEmail FROM `user` WHERE UserID = %d';
    	$result = $db->query($query, $user_id);

    	return $result->Data[0]['UserEmail'];
	}

	public function isAuthorised()
	{
		return ($this->UserID != -1);
	}

	public function isAdmin()
	{
		return false;
	}

	public static function createFromSession($session_key)
	{
		$return = new User();

		$db = DBConnect::getInstance();
		$res = $db->query('SELECT u.* FROM session s INNER JOIN user u ON (s.UserID = u.UserID) ' .
			'WHERE (CURRENT_TIMESTAMP - s.Created) <= %d AND s.SessionID = %d',
			SESSION_TIME, $session_key);

		if ($res->Size > 0)
		{
			$return->populateFromArray($res->Data[0]);

			if (User::checkEmployer($return->UserID) && isset($_SESSION['admin_rule']) && !defined('IS_ADMIN'))
			{
			    $return = new User($_SESSION['admin_rule']->UserID);
			}
		}

		return $return;
	}

	public static function createFromLogin($username, $password)
	{
		$user = new User();

		$db = DBConnect::getInstance();
		$res = $db->query('SELECT * FROM user WHERE Username = %s AND Password = %s', $username, md5($password));

		if ($res->Size > 0)
		{
			$user->populateFromArray($res->Data[0]);

			$session = new Session();
			$session->UserID = $user->UserID;
			$session->saveToDB();

			$_SESSION['sessionid'] = $session->SessionID;
		}

		return $user;
	}

	public static function createFromEmailLogin($userEmail, $password, $remember_me = false)
	{
		$user = new User();

		$db = DBConnect::getInstance();
		$res = $db->query('SELECT * FROM user WHERE UserEmail = %s AND Password = %s', $userEmail, md5($password));

		if ($res->Size > 0)
		{
			$user->populateFromArray($res->Data[0]);

			$session = new Session();
			$session->loginUser($user);

			if (true === $remember_me)
			{
				setcookie("sessionid", $session->SessionID, time() + SESSION_TIME);
			}
			else
			{
				$_SESSION['sessionid'] = $session->SessionID;
			}
		}

		return $user;
	}

	public function getShoppingCart()
	{
		return ShoppingCart::getUserShoppingCart($this->UserID);
	}

    public function sendMessage($UserID, $MessageSubject, $MessageText, $filename = "")
    {
        Message::sendUserMessage($this->UserID, $UserID, $MessageSubject, $MessageText, $filename);
    }

    public function sendEventInvite($userID, $eventID, $messageText)
	{
		Message::sendEventInvite($this->UserID, $userID, $eventID, $messageText);
	}

    public function sendUserMessage($UserID, $MessageSubject, $MessageText, $filename = "")
    {
    	return $this->sendMessage($UserID, $MessageSubject, $MessageText, $filename);
    }


    public function sendGroupMessage($groupID, $messageSubject, $messageText, $filename)
    {
    	$message = new Message();
    	$message->sendGroupMessage($this->UserID, $groupID, $messageSubject, $messageText, $filename);
    }

    public function sendOrganizationMessage($organizationID, $messageSubject, $messageText, $filename)
    {
    	$message = new Message();
    	$message->sendOrganizationMessage($this->UserID, $organizationID, $messageSubject, $messageText, $filename);
    }

    public function sendCommunityMessage($communityID, $messageSubject, $messageText, $filename)
    {
    	$message = new Message();
    	$message->sendCommunityMessage($this->UserID, $communityID, $messageSubject, $messageText, $filename);
    }

    public function getUnreadMessagesCount()
    {
        return Message::getUnreadUserMessagesCount($this->UserID);
    }

    public function getInboxMessages($messageType)
    {
        return Message::getInboxMessages($this->UserID,$messageType);
    }

    public function getSentMessages($messageType)
    {
        return Message::getSentMessages($this->UserID,$messageType);
    }

    public function getTrashMessages($messageType)
    {
        return Message::getTrashMessages($this->UserID,$messageType);
    }

    public function getMessagesCount($messageType, $messageStatus)
    {
    	return Message::getMessagesCount($this->UserID, $messageType, $messageStatus);
    }

    public function deleteMessages($messageType, $messageStatus)
    {
        return Message::deleteMessages($this->UserID, $messageType, $messageStatus);
    }

    public function getDeletedMessagesCount()
    {
        return Message::getDeletedMessagesCount($this->UserID);
    }

    public function emptySentMessages()
    {
    	Message::emptyUserSentMessages($this->UserID);
    }

    public function emptyDeletedMessages()
    {
    	Message::emptyUserTrash($this->UserID);
    }

	public function logout()
	{
		$db = DBConnect::getInstance();
		$db->delete('session', 'UserID = %d', $this->UserID);
		unset($_SESSION['sessionid']);
		session_destroy();
		setcookie("sessionid");
	}

	public function getPhotos($maxcount = null)
	{
		if ($this->UserID == -1)
		{
			return false;
		}

		$return = array();
		$db = DBConnect::getInstance();
		$query = $db->query('SELECT p.* FROM photo p INNER JOIN album a ON (p.AlbumID = a.AlbumID) where a.UserID = %d order by p.PhotoID desc' .
		($maxcount > 0 ? ' LIMIT ' . $maxcount : ''), $this->UserID);
		foreach ($query->Data as $row)
		{
			$photo = new Photo();
			$photo->populateFromArray($row);
			$return[] = $photo;
		}
		return $return;
	}

	public function getUserPhotos($maxcount = null)
	{
		return $this->getPhotos($maxcount);
	}

	public function getVideos($maxcount = null)
	{
		$return = array();
		$db = DBConnect::getInstance();
		$query = $db->query('SELECT v.* FROM video v INNER JOIN videoalbum a ON (v.VideoAlbumID = a.VideoAlbumID) where a.UserID = %d order by v.VideoID desc ' .
		($maxcount > 0 ? 'LIMIT ' . $maxcount : ''), $this->UserID);
		foreach ($query->Data as $row)
		{
			$photo = new Video();
			$photo->populateFromArray($row);
			$return[] = $photo;
		}
		return $return;
	}

	public function getVideoAlbums()
	{
		return VideoAlbum::getUserVideoAlbums($this->UserID);
	}

	public function getFiles($maxcount = null)
	{
		$return = array();
		$db = DBConnect::getInstance();
		$query = $db->query('SELECT * FROM file where UserID = %d ' .
		($maxcount > 0 ? 'LIMIT ' . $maxcount : ''), $this->UserID);
		foreach ($query->Data as $row)
		{
			$photo = new File();
			$photo->populateFromArray($row);
			$return[] = $photo;
		}
		return $return;
	}

    public function getUserNews()
	{
		return News::getUserNews($this->UserID);
	}

	public function getNewNewsCount()
	{
		$db = DBConnect::getInstance();
		$query = $db->query("SELECT COUNT(NewsID) AS n FROM `news` WHERE (UserID = %s) AND (DATEDIFF(CURDATE(), NewsDate) <= %d)", $this->UserID, PROFILE_UPDATE_PERIOD);
		return $query->Data['0']['n'];
	}

	public function getNewBlogComments()
	{
		return BlogComment::getNewUserBlogCommentsCount($this->UserID);
	}

	public function getNewPhotoComments()
	{
		return Comment::getNewUserPhotoCommentsCount($this->UserID);
	}

	public function getNewVideoComments()
	{
		return Comment::getNewUserVideoCommentsCount($this->UserID);
	}

	public function getSharedFiles($maxcount = null)
	{
		return array_slice(SharedFile::getUserFiles($this->UserID), 0, $maxcount);
	}

	public function getSharedFilesCount()
	{
		return SharedFile::getUserSharedFilesCount($this->UserID);
	}

	public function getSharedFilesRank()
	{
		$all = SharedFile::getAllSharedFilesCount();
		return $all ? $this->getSharedFilesCount() / $all : 0;
	}

	public function getTags()
	{
		return Tag::getUserTags($this->UserID);
	}

	public function getName()
	{
		return db_get_entity_display_name($this);
	}

    public static function checkEmployer($userID)
    {
        $db = DBConnect::getInstance();
        $result = $db->query('select count(*) as cnt from user where UserType = %d and UserID = %d', USER_TYPE_EMPLOYER, $userID);
        return (intval($result->Data[0]['cnt']) > 0);
    }

	public function checkPermission($intPermission)
	{
		return ($this->UserPermissions & $intPermission) == $intPermission;
	}

    public function addUser($userID)
    {
        return $this->addBuddy($userID);
    }

    public function addGroup($groupID)
    {
        $group = new Group($groupID);
        if ($group->GroupID != -1)
        {
            $group->addMember($this->UserID);
        }
    }

    public function addOrganization($orgID)
    {
        $org = new Organization($orgID);
        if ($org->OrganizationID != -1)
        {
            $org->addMember($this->UserID);
        }
    }

    public function getGroups($owneronly = false)
    {
    	return Group::getUserGroups($this->UserID, $owneronly);
    }

    public function getOrganizations($owneronly = false)
    {
    	return Organization::getUserOrganizations($this->UserID, $owneronly);
    }
}