<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

class UserBlock extends Entity
{
	public $UserBlockID			= -1;
	public $UserBlockType		= -1;
	public $UserBlockPattern	= '';
	public $UserBlockResources	= 0;  
	
	public function checkResource($intResource)
	{
		return ($this->UserBlockResources & $intResource) == $intResource;
	}
    
    public static function checkUserBlockResources($intUserBlockResources, $intResource)
    {
        return ($intUserBlockResources & $intResource) == $intResource;
    }
    
    public static function getUserBlock($type, $pattern)
    {
        $userBlock = new UserBlock();
        $userBlock->UserBlockType = $type;
        $userBlock->UserBlockPattern = $pattern;
        
        $db = DBConnect::getInstance();         
        $result = $db->query("select * from userblock where UserBlockType = %d and UserBlockPattern = %s", $type, $pattern);
        if ($result->Size > 0)
        {
            $userBlock->populateFromArray($result->Data[0]);
        }
        return $userBlock;
    }
    public static function getUserBlockedResources($userID)
    {  
        $return = 0;                         
        $user = new User($userID);
        if ($user->UserID != -1)
        {
            $db = DBConnect::getInstance();
            
            $query = 'select UserBlockResources from userblock where ' . 
                'UserBlockType = %d and UserBlockPattern like %p or ' . 
                'UserBlockType = %d and UserBlockPattern like %p';
            
            $params = array(USERBLOCK_TYPE_EMAIL, $user->UserEmail, USERBLOCK_TYPE_PHONE, $user->UserPhone);
            
            $result = $db->query($query, $params);
            foreach ($result->Data as $row)
            {
                $return |= $row['UserBlockResources'];
            }
        }
        return $return;
    }
}
?>