<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


class UploadedFile
{
	protected $error;
	protected $size;
	protected $path;
	protected $name;
	protected $type;

	function __construct($name, $type, $path, $size, $error)
	{
		$this->name = $name;
		$this->path = $path;
		$this->type = $type;
		$this->size = $size;
		$this->error = $error;
	}

	public function getName()
	{
		return $this->name;
	}

	public function getPath()
	{
		return $this->path;
	}

	public function getMimeType()
	{
		return $this->type;
	}

	public function getSize()
	{
		return $this->size;
	}

	public function getError()
	{
		return $this->error;
	}

	public function isValid()
	{
		return $this->error === UPLOAD_ERR_OK;
	}

	public function move($destination)
	{
		$result = false;
		if (file_exists($destination))
		{
			throw new UploadedFileException("Cannot overwrite uploaded file: the file '$destination' has been already existing");
		}
		$result = move_uploaded_file($this->getPath(), $destination);
		return $result;
	}

	public function delete()
	{
		unlink($this->getPath());
	}

	public function getContents()
	{
		return file_get_contents($this->path);
	}
}