<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 


function tpl_set_common_functions($template)
{
	$template->setCallbackFunction('if_equal', 'tpl_if_equal'); 
	$template->setCallbackFunction('strtolower', 'strtolower'); 
	$template->setCallbackFunction('date_format', 'tpl_date_format');
	$template->setCallbackFunction('if_empty', 'tpl_if_empty');
	$template->setCallbackFunction('if_true', 'tpl_if_true');
	$template->setCallbackFunction('self_link', 'cmn_self_link');
	$template->setCallbackFunction('cc_mask', 'tpl_cc_mask');
    $template->setCallbackFunction('get_profile_link', 'cmn_get_profile_link');
    $template->setCallbackFunction('html_entity_decode', 'html_entity_decode');
    $template->setCallbackFunction('english_ordinal', 'cmn_english_ordinal');
    $template->setCallbackFunction('if_mask', 'tpl_if_mask');
    $template->setCallbackFunction('price_format', 'tpl_price_format');
	
}

function tpl_price_format($number)
{
    return number_format($number, 2);
}

function tpl_cc_mask($cc, $size = 16)
{
	$return = '';
	for ($i = 0; $i < $size - 4; $i++)
	{
		$return .= 'X';
	}
    $return .= substr($cc, -4, 4);

	return $return;
}

function tpl_if_equal($value1, $value2, $string)
{
	if ($value1 == $value2)
	{
		return $string;
	}
}

function tpl_if_mask($value1, $value2, $string)
{
    
    if (($value1 & $value2) == $value1)
    {
        return $string;
    }
}

function tpl_if_true($var, $then, $else = '')
{
	return $var ? $then : $else;
}

function tpl_date_format($strDate, $format = 'j M Y')
{
	return empty($strDate) ? '' : date($format, strtotime($strDate));
}

function tpl_if_empty($var, $true, $false)
{
	return empty($var) ? $true : $false;
}

function tpl_render_select($template, $strPlace, $arrObjects, $id = -1)
{
	foreach ($arrObjects as $key => $object)
	{
		if (is_object($object))
		{
			$template->setVariable(get_object_vars($object));
			if ($object->{db_get_entity_key($object)} == $id)
			{
				$template->setVariable('selected', 'selected');
			}
			$template->parse($strPlace);
		}
		else
		{
			$template->setVariable('ID', $key);
			$template->setVariable('Value', $object);
			if ($id == $key)
			{
				$template->setVariable('selected', 'selected');
			}
			$template->parse($strPlace);
		}
	}
}

function tpl_render_select_multiple($template, $strPlace, $arrObjects, $id = array())
{
	foreach ($arrObjects as $key => $object)
	{
		if (is_object($object))
		{
			$template->setVariable(get_object_vars($object));
			if (in_array($object->{db_get_entity_key($object)}, $id) !== FALSE)
			{
				$template->setVariable('selected', 'selected');
			}
			$template->parse($strPlace);
		}
		else
		{
			$template->setVariable('ID', $key);
			$template->setVariable('Value', $object);
			if (in_array($key, $id) !== FALSE)
			{
				$template->setVariable('selected', 'selected');
			}
			$template->parse($strPlace);
		}
	}
}

function tpl_set_checkbox($template, $strPlace, $value)
{
	if ($value)
	{
		$template->setVariable($strPlace, 'checked');
	}
}


?>