<?php
//error_reporting(0);

/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require_once('../includes/classes/class.Sigma.php');
if(function_exists("set_time_limit")) 
{
    @set_time_limit(0);
}
session_start();

$page = !empty($_POST['page']) ? $_POST['page'] : 0;

$msg_system  = array();
$msg_folders = array();
$msg_wiki    = array();
$msg_config  = array();

$msg_adm     = array();
$msg_db      = "";

$messages = array();
$errors   = 0;

require('../settings/config.php');


switch ($page) 
{
    case 1:

	if (defined('DB_HOSTNAME'))
	{
            $msg_system[] = "<div class=\"error\">System already installed. Please delete database settings section from the /settings/config.php </div>";
            $errors ++;
	}
        else
        {
            $msg_system[] = "<div class=\"success\">System OK</div>";
        }

        if (!is_writable("../settings/config.php"))
        {
            if(!chmod("../settings/config.php", 777))
            {
                $msg_config[] = "<div class=\"error\"><strong>settings/config.php</strong> file is not writable. Check your permissions.</div>\n";
                $errors ++;
            }
        }

        if (sizeof($msg_config) == 0)
        {
            $msg_config[] = "<div class=\"success\"><strong>config.php</strong> file is writable.</div>";
        }


        $folders = array('download', 'tmp', 'userfiles', 'pics', 'csvUpload', 'data', 'files', 'forum/cache', 'forum/files', 'xls');
        foreach ($folders as $folder)
        {
            if (!is_writable("../$folder"))
            {
                if(!chmod("../$folder", 777))
                {
                    $msg_folders[] = "<div class=\"error\">The <strong>$folder</strong> folder or one of it subfolders is not writable.</div>";
                    $errors ++;
                }
            }
            else
            {
                $msg_folders[] = "<div class=\"success\">The <strong>$folder</strong> folder is writable.</div>";
            }
        }


        if(function_exists("curl_init")) 
        {
            $url = "http://www.socialabc.com/modules/NetworX/isonline.php?url=" . urlencode($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]); 
            $ch = curl_init(); 
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_FAILONERROR, 1); 
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POST, 1);
            $result = curl_exec($ch);
            curl_close($ch);  
        }
        else
        {
           $result="Fail";
        }

        if($result === "OK")
        {
            $msg_system[] = "<div class=\"success\">Test for remote URL</div>";
        }
        else
        {
            $msg_system[] = "<div class=\"error\">Test for remote URL failed. This will result in potentially other functionality failing.</div>";
        }


        if (!is_writable('../wiki/conf'))
        {
            if(!chmod('../wiki/conf', 777))
            {
                $msg_wiki[] = "<div class=\"error\">The <strong>wiki/conf</strong> folder and it content should be writable.</div>";
                $errors ++;
            }
        }


        if (!is_writable('../wiki/data'))
        {
            if(!chmod('../wiki/data', 777))
            {
                $msg_wiki[] = "<div class=\"error\">The <strong>wiki/data</strong> folder should be writable.</div>";
                $errors ++;
            }
        }

        else
        {
            $wiki_folders = array('attic', 'cache', 'index', 'locks', 'media', 'meta', 'pages', 'tmp');
            foreach ($wiki_folders as $folder)
            {
                if (!is_writable("../wiki/data/$folder"))
                {
                    if(!chmod("../wiki/data'.$folder", 777))
                    {
                        $msg_wiki[] = "<div class=\"error\">The <strong>wiki/data/$folder</strong> folder should be writable.</div>";
                        $errors ++;
                    }
                }
            }
        }


        if (sizeof($msg_wiki) == 0)
        {
            $msg_wiki[] = "<div class=\"success\">The NetworX <strong>WIKI</strong> is OK.</div>\n";
        }


        if(@$_POST["continue"] == 2 && !$errors)
        {

            $_POST["hostname"] = "localhost";

            $msg_db = "<p class=\"center\"><strong>Make sure you have created your database and granted full privileges to a user to use that database.</strong></p>";
            if(defined('DB_HOSTNAME'))
            {
                if(!@mysql_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD) || !@mysql_select_db(DB_DATABASE))
                {
                    $msg_db = "<div class=\"error\"><strong>Could not connect to the database. Verify that username and password are correct, and that the user has access to the given database.</strong></div>";
                }
                else
                {
                    $msg_db = "<div class=\"success\"><strong>Connection to the database was alredy installed.</strong></div>";

                    $_POST["hostname"] = DB_HOSTNAME;
                    $_POST["database"] = DB_DATABASE;
                    $_POST["username"] = DB_USERNAME;
                    $_POST["access"]   = "disabled";
                }
            }


            $tpl_name = "database.html";
            $page ++;
        }
        else
        {
            $tpl_name = "permissions.html";
        }
        break;


    case 2:

        $tpl_name = "database.html";

        $hostname = @$_POST['hostname'];
        $username = @$_POST['username'];
        $database = @$_POST['database'];
        $password = @$_POST['password'];

        if(defined('DB_HOSTNAME'))
        {
            $_POST['hostname'] = DB_HOSTNAME;
            $_POST['username'] = DB_USERNAME;
            $_POST['database'] = DB_DATABASE;
            $password = DB_PASSWORD;

            $_POST["access"]   = "disabled";
        }

        if(!@mysql_connect($_POST['hostname'], $_POST['username'], $password) || !@mysql_select_db($_POST['database']))
        {
            $msg_db = "<div class=\"error\"><strong>Could not connect to the database. Verify that username and password are correct, and that the user has access to the given database.</strong></div>";
            $errors ++;
        }
        else
        {
            $msg_db = "<div class=\"success\"><strong>Connection to the database was alredy installed.</strong></div>";
        }


        if(!$errors && @$_POST['continue'] == 3)
        {

            if(!defined('DB_HOSTNAME'))
            {
                $_SESSION['hostname'] = $host_cfg_line     = "define('DB_HOSTNAME', '" . $_POST['hostname'] . "');\r\n";
                $_SESSION['database'] = $db_cfg_line       = "define('DB_DATABASE', '" . $_POST['database'] . "');\r\n";
                $_SESSION['username'] = $username_cfg_line = "define('DB_USERNAME', '" . $_POST['username'] . "');\r\n";
                $_SESSION['password'] = $pass_cfg_line     = "define('DB_PASSWORD', '" . $_POST['password'] . "'); \r\n";
                
                $cfg_file = @fopen('../settings/config.php', 'a');
                
                @fwrite($cfg_file, "\r\n// database credentials \r\n");
                @fwrite($cfg_file, $host_cfg_line);
                @fwrite($cfg_file, $db_cfg_line);
                @fwrite($cfg_file, $username_cfg_line);
                @fwrite($cfg_file, $pass_cfg_line);
            }

            $msg_db    = "";
            $msg_adm[] = "<p class=\"center\"><strong>Select the username, password and email address for your admin account. Please make sure you record this password somewhere.</strong>";
            $tpl_name  = "admin.html";
            $page ++;
        }

        break;


    case 3:

        if (!@mysql_connect(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD) || !@mysql_select_db(DB_DATABASE))
        {
            $msg_adm[] = "<div class=\"error\">Could not connect to the database. Verify that username and password are correct, and that the user has access to the given database.</div>";
            $errors ++;
        }

        $sql = "";
        if(!file_exists("../sql/base.sql"))
        {
            $msg_adm[] = "<div class=\"error\">Could not found SQL script. Verify that path &quot;<strong>/sql/base.sql</strong>&quot;.</div>";
        }
        else
        {
            $sql = file_get_contents("../sql/base.sql");
        }

        if (empty($_POST["adminemail"]))
        {
            $msg_adm[] = "<div class=\"error\">You must supply an E-mail Address.</div>\n";
            $errors ++;
        }


        if (empty($_POST["adminpassword"]) || empty($_POST["adminpasswordagain"]))
        {
            $msg_adm[] = "<div class=\"error\">Please complete both password fields.</div>\n";
            $errors ++;
        }
        else
        {
            if($_POST["adminpassword"] != $_POST["adminpasswordagain"])
            {
                $msg_adm[] = "<div class=\"error\">Password fields do not match!</div>\n";
                $errors ++;
            }
        }


        $_POST["adminusername"] = $_POST["adminemail"];
        

        if(@$_POST['continue'] == 4 && !$errors)
        {
            //@require_once('../settings/config.php');

            $queries = explode(";\r\n", $sql);
            foreach ($queries as $query)
            {
                if ($query)
                {
                    mysql_query($query);
                }
            }

            $query = "UPDATE `user` SET `UserID`= 1,
                         `Username` = 'admin',
                         `Password` = '" . md5(trim($_POST['adminpassword'])) . "',
                         `UserFirstname` = 'admin',
                         `UserLastname` = 'admin',
                         `UserTitle` = 'admin',
                         `UserEmail` = '" . mysql_escape_string(trim($_POST['adminemail'])) . "',
                         `UserAddress1` = NULL,
                         `UserAddress2` = NULL,
                         `UserCity` = NULL,
                         `UserZip` = NULL,
                         `UserState` = NULL,
                         `UserCountry` = NULL,
                         `UserPhone` = NULL,
                         `UserMobilePhone` = NULL,
                         `UserFax` = NULL,
                         `UserPicture` = NULL,
                         `UserInterests` = NULL,
                         `UserStorage` = 0,
                         `UserStorageExpDate` = NULL,
                         `UserFavouriteMovies` = NULL,
                         `UserFavouriteBooks` = NULL,
                         `UserFavouriteFood` = NULL,
                         `UserFavouriteInterests` = NULL,
                         `UserFavouriteActivities` = NULL,
                         `UserFavouriteWebsites` = NULL,
                         `UserResume` = NULL,
                         `UserRegistrationDate` = NULL,
                         `UserFavoritesPrivacy` = 0,
                         `UserEducationPrivacy` = 0,
                         `UserWorkPrivacy` = 0,
                         `UserJobPrivacy` = 0,
                         `UserCalendarPrivacy` = 0,
                         `UserStatus` = NULL,
                         `UserInterestsOther` = NULL,
                         `UserYahoo` = NULL,
                         `UserSkype` = NULL,
                         `UserMSN` = NULL,
                         `UserAOL` = NULL,
                         `OnlyMyFlags` = 0,
                         `UserType` = 1,
                         `UserMessagingCredit` = NULL,
                         `UserPermissions` = 1023,
                         `UserUpdated` = '0000-00-00 00:00:00',
                         `UserForumID` = NULL
                         WHERE `UserID` = 1;";

            if (!@mysql_query($query))
            {
                $msg_adm[] = "<div class=\"error\">Could not execute query.</div>";
                $errors ++;
            }
            else
            {
                $local_php = @fopen('../wiki/conf/local.php', 'a');
                @fwrite($local_php, "\r\n\$conf['superuser'] = '@" . trim($_POST['adminusername']) . "';  \r\n");

                $users_auth_php = @fopen('../wiki/conf/users.auth.php', 'a');
                @fwrite($users_auth_php, "\r\n".trim($_POST['adminusername']).":".md5(trim($_POST['adminpassword'])).":".trim($_POST['adminusername']).":" . trim($_POST['adminemail']) . ":admin,user \r\n");


                if(!defined('IN_PHPBB'))
                {
                   define('IN_PHPBB', true);
                }

                $phpbb_root_path = '../forum/';
                $phpEx = substr(strrchr(__FILE__, '.'), 1);
                require($phpbb_root_path . 'common.' . $phpEx);
                require($phpbb_root_path . 'includes/functions_user.' . $phpEx);
                require($phpbb_root_path . 'includes/functions_module.' . $phpEx);
                $password = phpbb_hash(trim($_POST['adminpassword']));
                $sql = "update phpbb_users set " . 
                "username = 'admin', " . 
                "username_clean = '" . utf8_clean_string($_POST['adminusername']) . "', " .
                "user_password = '" . mysql_escape_string($password) . "' " . 
                "where user_id = 2";
                @mysql_query($sql);                    
            }
        }

        if (@$_POST['continue'] == 4 && !$errors)
        {
            $tpl_name = "path.html";
            $page ++;
        }
        else
        {
            $tpl_name = "admin.html";
        }
	break;

    case 4:
        $tpl_name = 'path.html';
	break;


    default:
	$tpl_name = 'welcome.html';
	$page++;
}


$template = new HTML_Template_Sigma('./templates', './templates/cache');
$template->loadTemplateFile($tpl_name);
$template->setGlobalVariable('page', $page);
$template->setGlobalVariable('SITE_URL', 'http://'.$_SERVER['SERVER_NAME']);


/* template variables */
if (sizeof($msg_system) > 0) {
    foreach ($msg_system as $item) {
        $template->setVariable('system_text', $item);
        $template->parse('system');
    }
}


if (sizeof($msg_config) > 0) {
    foreach ($msg_config as $item) {
        $template->setVariable('config_text', $item);
        $template->parse('config');
    }
}


if (sizeof($msg_folders) > 0) {
    foreach ($msg_folders as $item) {
        $template->setVariable('folders_text', $item);
        $template->parse('folders');
    }
}


if (sizeof($msg_wiki) > 0) {
    foreach ($msg_wiki as $item) {
        $template->setVariable('wiki_text', $item);
        $template->parse('wiki');
    }
}


if($msg_db){
   $template->setVariable("message_text", $msg_db);
   $template->parse("messages");
}


if (sizeof($msg_adm) > 0) {
    foreach ($msg_adm as $item) 
    {
        $template->setVariable('message_text', $item);
        $template->parse('messages');
    }
}


$template->setVariable($_POST);
$template->show();
?>