<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unauthorized_action();
}

$entity = isset($_GET['entity']) ? $_GET['entity'] : ( isset($_POST['Entity']) ? $_POST['Entity'] : 'User');
$id = isset($_GET['id']) ? $_GET['id'] : ( isset($_POST['ID']) ? $_POST['ID'] : $user->UserID);

$object = Entity::getObject($entity, $id);
//$address = $object->{ucfirst($entity) . 'City'};
$is_center_set = false;

// My Connections
$global_connections = $object->getConnections(array('ConnectionType' => array(CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, CONNECTIONTYPE_BUDDY)));

foreach ($global_connections as $global_connection)
{
	$map_template = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);
	$map_template->loadTemplateFile('map.connections.html');

	$global_target = $global_connection->getTarget($object);
	$members = $global_target->getMembers();

	$global_table = db_get_table_name($global_target);
	$address = trim($global_target->{ucfirst($global_table) . 'City'} . ' ' . $global_target->{ucfirst($global_table) . 'Address1'} . ' ' . $global_target->{ucfirst($global_table) . 'Zip'});

	if (!empty($address))
	{
		$is_center_set = true;

		foreach ($members as $member)
		{
			$connections = $member->getConnections();
			$connection_names_string = '';
			foreach ($connections as $connection)
			{
				$target = $connection->getTarget($member);
				$table = db_get_table_name($target);
				if ($table == 'user')
				{
					$table = 'member';
				}
				$connection_names_string .= '<a href="' . $table . '.php?' . $table . '_id=' . $target->{db_get_entity_key($target)} . '">' . $target->getName() . '</a><br />';
			}
		    $connection_names_string = rtrim($connection_names_string, ", ");
			$map_template->setVariable('ConnectionNamesString', $connection_names_string);

			$map_template->setVariable('UserFirstname', $member->UserFirstname);
			$map_template->setVariable('UserLastname', $member->UserLastname);
		    $user_pic_URL = PATH_USER_PICS . $member->UserID . '/50px/' . $member->UserPicture;
			$map_template->setVariable('UserPictureURL', $user_pic_URL);
			$map_template->parse('member');
		}

		switch (strtolower($entity))
		{
			case 'group': $entities = 'Groups';
			break;
			case 'organization': $entities = 'Organizations';
			break;
			case 'community': $entities = 'Communities';
		}

		$map_template->setVariable('ENTITIES', $entities);
		$map_template->setVariable('entity', strtolower($entity) == 'user' ? 'member' : strtolower($entity));
		$map_template->setVariable('id', $id);
		$info = $map_template->get();

		$template->setVariable('ConnectionHtml', $info);
		$template->setVariable('ConnectionHtmlID', $global_connection->ConnectionID);
		$template->parse('connection_html');

		$template->setVariable('Address', $address);
		$template->setVariable('ConnectionHtmlID', $global_connection->ConnectionID);
		$template->parse('connection_info');
	}
}

// Files
$files = $object->getSharedFiles();
$map_template = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);

foreach ($files as $file)
{
	$tags = $file->getTags();

	foreach ($tags as $tag)
	{
		$locations = $tag->getLocations();

		foreach ($locations as $location)
		{
			$address = trim($COUNTRIES[$location->TagLocationCountry] . ' ' . $location->TagLocationState . ' ' . $location->TagLocationCity);
			if (!empty($address))
			{
				$is_center_set = true;

				$map_template->loadTemplateFile('map.files.html');

				$map_template->setVariable('FileID', $file->SharedFileID);
				$map_template->parse('file');
				$map_template->setVariable('entity', strtolower($entity));
				$map_template->setVariable('id', $id);

				$info = $map_template->get();

				$template->setVariable('FileHtml', $info);
				$template->setVariable('FileHtmlID', $location->TagLocationID);
				$template->parse('file_html');

				$template->setVariable('Address', $address);
				$template->setVariable('FileHtmlID', $location->TagLocationID);
				$template->parse('file_info');
			}
		}
	}
}

// Photos
//$photos = $object->getPhotos();
$albums = $object->getAlbums();
$map_template = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);

foreach ($albums as $album)
{
	//$photos = $album->getPhotos();
	//foreach ($photos as $photo)
	//{
		$tags = $album->getTags();



		foreach ($tags as $tag)
		{
			$locations = $tag->getLocations();

			foreach ($locations as $location)
			{
				$address = trim($COUNTRIES[$location->TagLocationCountry] . ' ' . $location->TagLocationState . ' ' . $location->TagLocationCity);
				if (!empty($address))
				{
					$is_center_set = true;

					$map_template->loadTemplateFile('map.photos.html');

					$map_template->setVariable('AlbumID', $album->AlbumID);
					$map_template->parse('photo');
					$map_template->setVariable('entity', strtolower($entity));
					$map_template->setVariable('id', $id);

					$info = $map_template->get();

					$template->setVariable('PhotoHtml', $info);
					$template->setVariable('PhotoHtmlID', $location->TagLocationID);
					$template->parse('photo_html');

					$template->setVariable('Address', $address);
					$template->setVariable('PhotoHtmlID', $location->TagLocationID);
					$template->parse('photo_info');
				}
			}
		}
	//}
}

// Videos
$videos = $object->getVideoAlbums();
$map_template = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);

foreach ($videos as $video)
{
	$tags = $video->getTags();

	foreach ($tags as $tag)
	{
		$locations = $tag->getLocations();

		foreach ($locations as $location)
		{
			$address = trim($COUNTRIES[$location->TagLocationCountry] . ' ' . $location->TagLocationState . ' ' . $location->TagLocationCity);
			if (!empty($address))
			{
				$is_center_set = true;

				$map_template->loadTemplateFile('map.videos.html');

				$map_template->setVariable('VideoAlbumID', $video->VideoAlbumID);
				$map_template->parse('video');
				$map_template->setVariable('entity', strtolower($entity));
				$map_template->setVariable('id', $id);

				$info = $map_template->get();

				$template->setVariable('VideoHtml', $info);
				$template->setVariable('VideoHtmlID', $location->TagLocationID);
				$template->parse('video_html');

				$template->setVariable('Address', $address);
				$template->setVariable('VideoHtmlID', $location->TagLocationID);
				$template->parse('video_info');
			}
		}
	}
}

if (strtolower($entity) == 'user')
{
	// Blog Entries
	$blog_entries = $object->getBlogEntries();
	$map_template = new HTML_Template_Sigma(PATH_TEMPLATES, PATH_TEMPLATES_CACHE);

	foreach ($blog_entries as $blog_entry)
	{
		$tags = $blog_entry->getTags();

		foreach ($tags as $tag)
		{
			$locations = $tag->getLocations();

			foreach ($locations as $location)
			{
				$address = trim($COUNTRIES[$location->TagLocationCountry] . ' ' . $location->TagLocationState . ' ' . $location->TagLocationCity);
				if (!empty($address))
				{
					$is_center_set = true;

					$map_template->loadTemplateFile('map.blogs.html');

					$map_template->setVariable('BlogEntryID', $blog_entry->BlogEntryID);
					$map_template->parse('blog');
					$map_template->setVariable('entity', strtolower($entity));
					$map_template->setVariable('id', $id);

					$info = $map_template->get();

					$template->setVariable('BlogHtml', $info);
					$template->setVariable('BlogHtmlID', $location->TagLocationID);
					$template->parse('blog_html');

					$template->setVariable('Address', $address);
					$template->setVariable('BlogHtmlID', $location->TagLocationID);
					$template->parse('blog_info');
				}
			}
		}
	}

	// user himself
	$map_template->loadTemplateFile('map.connections.html');
	$address = trim($COUNTRIES[$object->UserCountry] . ' ' . $object->UserCity . ' ' . $object->UserAddress1 . ' ' . $object->UserZip);

	if (!empty($address))
	{
		$is_center_set = true;
		$member = $object;

		//$connections = $member->getConnections();

		$connection_names_string = '';
		$db = DBConnect::getInstance();
		$result = $db->query('select distinct * from `connection` where ' .
			'(ConnectionType = %d or ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) and UserID = %d limit 5',
			CONNECTIONTYPE_BUDDY, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $member->UserID);

		foreach ($result->Data as $data)
		{
			$connection = new Connection();
			$connection->populateFromArray($data);

			$target = $connection->getTarget($member);
			$table = db_get_table_name($target);
			if ($table == 'user')
			{
				$table = 'member';
			}
			$connection_names_string .= '<a href="' . $table . '.php?' . $table . '_id=' . $target->{db_get_entity_key($target)} . '">' . $target->getName() . '</a><br />';
		}
	    $connection_names_string = rtrim($connection_names_string, ", ");
		$map_template->setVariable('ConnectionNamesString', $connection_names_string);

		$map_template->setVariable('UserFirstname', $member->UserFirstname);
		$map_template->setVariable('UserLastname', $member->UserLastname);
	    $user_pic_URL = PATH_USER_PICS . $member->UserID . '/50px/' . $member->UserPicture;
		$map_template->setVariable('UserPictureURL', $user_pic_URL);
		$map_template->parse('member');

		$map_template->setVariable('ENTITIES', $entities);
		$map_template->setVariable('entity', 'member');
		$map_template->setVariable('id', $id);
		$info = $map_template->get();

		$template->setVariable('ConnectionHtml', $info);
		$template->setVariable('ConnectionHtmlID', '0');
		$template->parse('connection_html');

		$template->setVariable('Address', $address);
		$template->setVariable('ConnectionHtmlID', '0');
		$template->parse('connection_info');
	}
}

if (!empty($_GET['search']))
{
	$template->setVariable('SearchStr', $_GET['search']);
	$template->parse('search_occasion');
}

if (!$is_center_set)
{
	$template->touchBlock('set_center');
}
$template->setVariable('entity', strtolower($entity));
$template->setVariable('id', $id);

require("includes/application_bottom.php");