<?php
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

require("includes/application_top.php");

$template->loadTemplateFile("privacy_popup.html");

if (!Session::isCurrentSessionLoggedIn())
{
	cmn_unathorized_action();
}

$privacy_type = $_POST['privacy_type'] ? $_POST['privacy_type'] : $_GET['privacy_type'];

if ($privacy_type == 'blog_entry')
{
	$entry_id = $_GET['entry_id'];

	if ($_POST['action'] == 'save')
	{
		BlogEntry::removeAllPrivacyConnectionsOfThisEntry($entry_id);

		// get group id's
		$groups = $_POST['GroupID'];

		foreach ($groups as $group_id)
		{
			BlogEntry::allowGroupMembersToReadThisEntry($group_id, $entry_id);

		}

		// get individual id's
		$people = $_POST['Individuals_items'];

		foreach ($people as $user_id)
		{
			BlogEntry::allowUserToReadThisEntry($user_id, $entry_id);
		}
		$template->touchBlock('close_window');

	}
	elseif ($_GET['action'] == 'unset')
	{
		BlogEntry::removeAllPrivacyConnectionsOfThisEntry($entry_id);
		BlogEntry::togglePrivacyFlagState($entry_id, PRIVACY_FLAG_BLOGENTRY_UNSET);
		$template->touchBlock('close_window');
	}
	elseif ($_GET['action'] == 'set')
	{
		BlogEntry::togglePrivacyFlagState($entry_id, PRIVACY_FLAG_BLOGENTRY_SET);

		// display user groups
		$groups = $user->getGroups();
		if (count($groups))
		{
			foreach ($groups as $group)
			{
				$template->setVariable('GroupID', $group->GroupID);
				$template->setVariable('GroupName', $group->GroupName);

				$members = $group->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('group_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('group_item');
						}
					}
				}
				$template->setVariable('GroupID', $group->GroupID);
				$template->parse('group');
			}
			$template->parse('Groups');
		}

		// display user organizations
		$organizations = $user->getOrganizations();
		if (count($organizations))
		{
			foreach ($organizations as $organization)
			{
				$template->setVariable('OrganizationID', $organization->OrganizationID);
				$template->setVariable('OrganizationName', $organization->OrganizationName);

				$members = $organization->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('organization_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('organization_item');
						}
					}
				}
				$template->setVariable('OrganizationID', $organization->OrganizationID);
				$template->parse('organization');
			}
			$template->parse('Organizations');
		}

		// display user communities
		$communities = $user->getCommunities();
		if (count($communities))
		{
			foreach ($communities as $community)
			{
				$template->setVariable('CommunityID', $community->CommunityID);
				$template->setVariable('CommunityName', $community->CommunityName);

				$members = $community->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('community_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('community_item');
						}
					}
				}
				$template->setVariable('CommunityID', $community->CommunityID);
				$template->parse('community');
			}
			$template->parse('Communities');
		}

		// display users (individuals)
		$individuals = $user->getConnectedUsers();
		foreach ($individuals as $individual)
		{
			$template->setVariable('IndividualID', $individual->UserID);
			$template->setVariable('IndividualName', db_get_entity_display_name($individual));

			$template->parse('Individual');
		}

		$template->setVariable('privacy_type', $_GET['privacy_type']);
	}
	else
	{
		cmn_unauthorized_action();
	}
}
else
{
	if ($_POST['action'] == 'save')
	{
		$individuals = array();
		$groups = array();
		$organizations = array();
		$communities = array();

		/*
		foreach ($_POST as $key => $value)
		{
			if (preg_match("/^gr_[\d]+$/", $key))
			{
				$groups[] = $value[0];
			}
			if (preg_match("/^gr_[\d]+_items$/", $key))
			{
				$individuals[] = $value[0];
			}
			if (preg_match("/^org_[\d]+$/", $key))
			{
				$organizations[] = $value[0];
			}
			if (preg_match("/^org_[\d]+_items$/", $key))
			{
				$individuals[] = $value[0];
			}
			if (preg_match("/^com_[\d]+$/", $key))
			{
				$communities[] = $value[0];
			}
			if (preg_match("/^com_[\d]+_items$/", $key))
			{
				$individuals[] = $value[0];
			}
		}

		Connection::dropGroupPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		foreach ($groups as $group_id)
		{
			Connection::setGroupPrivacyAccessPrivilegies($privacy_type, $user->UserID, $group_id);
		}

		Connection::dropOrganizationPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		foreach ($organizations as $organization_id)
		{
			Connection::setOrganizationPrivacyAccessPrivilegies($privacy_type, $user->UserID, $organization_id);
		}

		Connection::dropCommunityPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		foreach ($communities as $community_id)
		{
			Connection::setCommunityPrivacyAccessPrivilegies($privacy_type, $user->UserID, $community_id);
		}
		*/

		$people = array_merge($individuals, $_POST['Individuals_items']);
		Connection::dropUserPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		foreach ($people as $user_id)
		{
			Connection::setUserPrivacyAccessPrivilegies($privacy_type, $user->UserID, $user_id);
		}
		$template->touchBlock('close_window');
	}
	elseif ($_GET['action'] == 'unset')
	{
		Connection::setAllUserPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		Connection::setAllGroupPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		Connection::setAllOrganizationPrivacyAccessPrivilegies($privacy_type, $user->UserID);
		$template->touchBlock('close_window');
	}
	elseif ($_GET['action'] == 'set')
	{
		// display user groups
		$groups = $user->getGroups();
		if (count($groups))
		{
			foreach ($groups as $group)
			{
				$template->setVariable('GroupID', $group->GroupID);
				$template->setVariable('GroupName', $group->GroupName);

				$members = $group->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('group_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('group_item');
						}
					}
				}
				$template->setVariable('GroupID', $group->GroupID);
				$template->parse('group');
			}
			$template->parse('Groups');
		}

		// display user organizations
		$organizations = $user->getOrganizations();
		if (count($organizations))
		{
			foreach ($organizations as $organization)
			{
				$template->setVariable('OrganizationID', $organization->OrganizationID);
				$template->setVariable('OrganizationName', $organization->OrganizationName);

				$members = $organization->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('organization_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('organization_item');
						}
					}
				}
				$template->setVariable('OrganizationID', $organization->OrganizationID);
				$template->parse('organization');
			}
			$template->parse('Organizations');
		}

		// display user communities
		$communities = $user->getCommunities();
		if (count($communities))
		{
			foreach ($communities as $community)
			{
				$template->setVariable('CommunityID', $community->CommunityID);
				$template->setVariable('CommunityName', $community->CommunityName);

				$members = $community->getMembers();
				if ( (count($members) == 1) && ($members[0]->UserID == $user->UserID) )
				{
					$template->touchBlock('community_members_empty');
				}
				else
				{
					foreach ($members as $member)
					{
						if ($member->UserID != $user->UserID)
						{
							$template->setVariable('MemberID', $member->UserID);
							$template->setVariable('MemberName', db_get_entity_display_name($member));
							$template->parse('community_item');
						}
					}
				}
				$template->setVariable('CommunityID', $community->CommunityID);
				$template->parse('community');
			}
			$template->parse('Communities');
		}

		// display users (individuals)
		$individuals = $user->getConnectedUsers();
		foreach ($individuals as $individual)
		{
			$template->setVariable('IndividualID', $individual->UserID);
			$template->setVariable('IndividualName', db_get_entity_display_name($individual));

			$template->parse('Individual');
		}

		$template->setVariable('privacy_type', $_GET['privacy_type']);
	}
	else
	{
		cmn_unauthorized_action();
	}
}

require("includes/application_bottom.php");