<?
/*
NetworX - open-source social networks platform
Copyright (C) 2009 SocialABC, Inc. http://www.socialabc.com
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program in a file called LICENSE; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/ 

include('includes/application_top.php');

if (Session::isCurrentSessionLoggedIn())
{
	$entities = array
	(
		'User'			=> 0,
		'Group'			=> 0,
		'Organization'	=> 0,
		'Community'		=> 0,
		'BlogEntry'		=> 0,
		'News'			=> 0,
		'Media'			=> 0
	);

	$display = 'user';
	foreach ($entities as $entity => $tmp)
	{
		if (strtolower($entity) == $_GET['display'])
		{
			$display = $_GET['display'];
		}
	}

	if (!empty($_GET['search']))
	{
		$search = ud_sanitize($_GET['search']);

		$mode = $_GET['mode'];				
		
		switch ($_GET['mode'])
		{
			case 'tags':
				$entities['User']  = 'left join `tag` t on t.UserID = u.UserID where UPPER(t.TagName) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Group'] = 'left join `tag` t on t.GroupID = co.GroupID where UPPER(t.TagName) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Organization'] = 'left join `tag` t on t.OrganizationID = co.OrganizationID where UPPER(t.TagName) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Community'] = 'left join `tag` t on t.CommunityID = co.CommunityID where UPPER(t.TagName) like \'%%' . strtoupper($search) . '%%\'';
				
				break;
				
			case 'location':
				$entities['User'] = 'where UserCity like \'%%' . $search . '%%\' or UPPER(UserAddress1) like \'%%' . strtoupper($search) . 
					'%%\' or UPPER(UserAddress2) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Group'] = 'where GroupCity like \'%%' . $search . '%%\' or UPPER(GroupAddress1) like \'%%' . strtoupper($search) . 
					'%%\' or UPPER(GroupAddress2) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Organization'] = 'where UPPER(OrganizationCity) like \'%%' . strtoupper($search) . '%%\' or UPPER(OrganizationAddress1) like \'%%' . strtoupper($search) . 
					'%%\' or UPPER(OrganizationAddress2) like \'%%' . strtoupper($search) . '%%\'';		
					
				
				break;
				
			default:
				$mode = 'keywords';
				$entities['User'] = 'where UPPER(UserFirstname) like \'%%' . strtoupper($search) . '%%\' or UPPER(UserLastname) like \'%%' . strtoupper($search) . '%%\' or UPPER(UserTitle) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Group'] = 'where UPPER(GroupName) like \'%%' . strtoupper($search) . '%%\' or UPPER(GroupKeywords) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Organization'] = 'where UPPER(OrganizationName) like \'%%' . strtoupper($search) . '%%\' or UPPER(OrganizationKeywords) like \'%%' . strtoupper($search) . '%%\'';
				$entities['Community'] = 'where UPPER(CommunityName) like \'%%' . strtoupper($search) . '%%\' or UPPER(CommunityKeywords) like \'%%' . strtoupper($search) . '%%\'';
				$entities['BlogEntry'] = 'where (UPPER(BlogEntrySubject) like \'%%' . strtoupper($search) . '%%\' or UPPER(BlogEntryMessage) like \'%%' . strtoupper($search) . '%%\' or UPPER(BlogEntryKeywords) like \'%%' . strtoupper($search) . '%%\')';
				$entities['News'] = 'where (UPPER(NewsName) like \'%%' . strtoupper($search) . '%%\' or UPPER(NewsKeywords) like \'%%' . strtoupper($search) . '%%\' or UPPER(NewsText) like \'%%' . strtoupper($search) . '%%\')';
				$entities['Media'] = 'UPPER(Name) like \'%%' . strtoupper($search) . '%%\'';
		}
		
		$template->setVariable('FastSearchString', $search);
		$template->setVariable('FastSearchMode', $mode);

		$db = DBConnect::getInstance();

		foreach ($entities as $entity => $where)
		{
			
			if ($where)
			{
				$table = strtolower($entity);
				switch ($entity)
				{
					case 'User':

						if ($table == $display)
						{
							$listing = new Listing('listing.connections.html', 'listing');
							$listing->onBeforeParseRow = parseConnection;

							$listing->parse($template, 'SELECT count(con.ConnectionID) AS Connections, UserRegistrationDate AS Created, ' .
								'UserUpdated AS Updated, u.UserPicture AS Picture, \'User\' AS Entity,
								CONCAT_WS(\' \', u.UserFirstname, \' \', u.UserLastname) AS Title, u.UserID AS ID ' . 
								' FROM `user` AS u LEFT JOIN `connection` AS con ON (con.UserID = u.UserID AND ' . 
								'(con.ConnectionType = ' . CONNECTIONTYPE_MEMBER . ' OR con.ConnectionType = ' . CONNECTIONTYPE_ADMIN . 
								' OR con.ConnectionType = ' . CONNECTIONTYPE_OWNER . ') OR con.ConnectionType = ' . CONNECTIONTYPE_BUDDY . 
								' AND (con.ToUserID = u.UserID OR con.UserID = u.UserID)) ' . 
								'  ' . $where .
								' and UserType = ' . USER_TYPE_MEMBER . 
								' GROUP BY u.UserID');

							$entities[$entity] = $listing->DataSource->Size;
						}
						else
						{

			                $result = $db->query('SELECT COUNT(*) AS cnt FROM `user` u ' . $where . ' and UserType = ' . USER_TYPE_MEMBER);
							$entities[$entity] = $result->Data[0]['cnt'];
						}

						break;

					case 'Group':
						$where .= ' and (GroupStatus != ' . GROUP_STATUS_PRIVATE . ')';
						
					case 'Organization':
					case 'Community':
						
						if ($table == $display)
						{
							$listing = new Listing('listing.connections.html', 'listing');
							$listing->onBeforeParseRow = parseConnection;
							$listing->parse($template, 'SELECT COUNT(con.ConnectionID) AS Connections, ' . $entity . 'Created AS Created, ' .
								$entity . 'Updated AS Updated, ' . $entity . 'Picture AS Picture, \'' . $entity . '\' AS Entity, co.' . $entity .
								'Name' . ' AS Title, co.' . $entity . 'ID AS ID FROM `' . $table . 
								'` co LEFT JOIN `connection` AS con ON con.ConnectionType = ' .
								CONNECTIONTYPE_MEMBER . ' AND con.' . $entity . 'ID' . ' = co.' . $entity . 'ID AND con.UserID = -1 ' . 
								' ' . $where . ' GROUP BY co.' . 
								$entity . 'ID');

							$entities[$entity] = $listing->DataSource->Size;
						}
						else
						{
							$result = $db->query('SELECT COUNT(*) AS cnt FROM `' . $table . '` AS co ' . $where);
							$entities[$entity] = $result->Data[0]['cnt'];
						}

						break;
						
					case 'BlogEntry':

						$query = 'from blogentry b ' .
							'inner join `blogentryprivacyconnection` AS bepc on b.BlogEntryID = bepc.BlogEntryID ' . 
							'left JOIN `connection` AS c ON c.GroupID = bepc.GroupID AND bepc.GroupID <> -1 and c.UserID=' . 
							$user->UserID . ' and (c.ConnectionType = ' . CONNECTIONTYPE_ADMIN . 
							' or c.ConnectionType = ' . CONNECTIONTYPE_OWNER . ' or c.ConnectionType = ' . CONNECTIONTYPE_MEMBER . ') ' . 
							$where . ' and (bepc.UserID=' .	$user->UserID . ' or c.ConnectionID is not null and PrivacyFlag = ' . 
							PRIVACY_FLAG_BLOGENTRY_SET . ' and not OnlyMyFlag) group by b.BlogEntryID';
									
						if ($table == $display)
						{
							$listing = new Listing('listing.blogentry.html', 'listing');						
							$listing->parse($template, 'select BlogEntryDate, BlogEntrySubject, BlogEntryMessage ' . $query);
							
							$entities[$entity] = $listing->DataSource->Size;
						}
						else
						{
							$result = $db->query('SELECT COUNT(*) AS cnt ' . $query);
						
							$entities[$entity] = $result->Data[0]['cnt'];
						}
						break;
						
					case 'News':
					
						$query = 'from news n ' .
							'left JOIN `connection` AS c ON (c.OrganizationID = n.OrganizationID AND n.OrganizationID <> -1 or c.GroupID = n.GroupID AND n.GroupID <> -1 or c.CommunityID = n.CommunityID AND n.CommunityID <> -1) and c.UserID=' . 
							$user->UserID . ' and (c.ConnectionType = ' . CONNECTIONTYPE_ADMIN . 
							' or c.ConnectionType = ' . CONNECTIONTYPE_OWNER . ' or c.ConnectionType = ' . CONNECTIONTYPE_MEMBER . ') ' . 
							$where . ' and (n.UserID=' .	$user->UserID . ' or c.ConnectionID is not null) group by n.NewsID';
									
						if ($table == $display)
						{
							$listing = new Listing('listing.news.html', 'listing');						
							$listing->parse($template, 'select NewsDate, NewsText, NewsName ' . $query);
							
							$entities[$entity] = $listing->DataSource->Size;
						}
						else
						{
							$result = $db->query('SELECT COUNT(*) AS cnt ' . $query);
							$entities[$entity] = $result->Data[0]['cnt'];
						}
						break;
						

					case 'Media':
					
						$query = 'select PhotoID as ID, PhotoName as Name, \'Photo\' as Entity from `photo` where Photo' . $where . ' union ' .
							'select VideoID as ID, VideoName as Name, \'Video\' as Entity from `video` where Video' . $where . ' union ' .
							'select FileID as ID, FileName as Name, \'File\' as Entity from `file` where File' . $where;
							
						if ($table == $display)
						{
							$listing = new Listing('listing.media.html', 'listing');						
							$listing->onBeforeParseRow = 'parseMedia';
							$listing->parse($template, $query);
							
							$entities[$entity] = $listing->DataSource->Size;
						}
						else
						{
							$db = DBConnect::getInstance();
							$result = $db->query($query);
							$entities[$entity] = $result->Size;
						}
						break;						
				}
			}
		}
	}

	$template->touchBlock($display . '_selected');
	$template->setGlobalVariable('ChangeTabLink', cmn_self_link('display', '', array('limit', 'page')));
	
	
	foreach ($entities as $entity => $count)
	{
		$template->setVariable($entity . 'Count', intval($count));
	}
}
else
{
	cmn_unauthorized_action();
}



function parseConnection($tpl, $row)
{
	$tpl->setVariable('EntityLink', cmn_get_profile_link($row['Entity'], $row['ID']));
	$tpl->hideBlock('checkbox');
	
	$db = DBConnect::getInstance();
	if ($row['Entity'] == 'User')
	{
		$result = $db->query('select * from `connection` where ' .
			'(ConnectionType = %d or ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) and UserID = %d limit 5',
			CONNECTIONTYPE_BUDDY, CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID']);
	}
	else
	{
		$result = $db->query('select * from `connection` where (ConnectionType = %d or ConnectionType = %d or ConnectionType = %d) ' .
			'and (' . $row['Entity'] . 'ID' . ' = %d or To' . $row['Entity'] . 'ID' . ' = %d) and UserID = -1 limit 5',
			CONNECTIONTYPE_MEMBER, CONNECTIONTYPE_ADMIN, CONNECTIONTYPE_OWNER, $row['ID'], $row['ID']);
	}

	foreach ($result->Data as $data)
	{
		$connection = new Connection();
		$connection->populateFromArray($data);

		$target = $connection->getTarget($obj);

		$tpl->setVariable('ConnectionLink', cmn_get_profile_link(get_class($target), $target->{db_get_entity_key($target)}));
		$tpl->setVariable('ConnectionTitle', $target->{db_get_entity_name($target)});
		$tpl->parse('connection');
	}

	if (!count($result->Data))
	{
		$tpl->touchBlock('connections_none');
	}
	//////

	if (empty($row['Picture']))
	{
		$tpl->touchBlock('no_picture');
		$tpl->hideBlock('picture');
	}
}

function parseMedia($tpl, $row)
{
	$obj = Entity::getObject($row['Entity'], $row['ID']);
	if (get_class($obj) != 'Entity')
	{
		$tpl->setVariable('ImgURL', $obj->{'get' . $row['Entity'] . 'URL'}(true));
	}
}

include('includes/application_bottom.php');
?>